Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class CFRGetSection
	
    'Copyright (c) 2001, 2001, Roger Jennings and OakLeaf Systems
    'All World-Wide Rights Reserved
    'See the License.txt file in this project's folder for terms
    'and conditions of use of this and other related code.

    Private domDoc As New MSXML2.DOMDocument30()
	Private cnnCFR As New ADODB.Connection
	Private cmmCFR As New ADODB.Command
	
	Private strRevDate As String
	Private gstrXMLPrefix As String
	Private gstrCFRSect As String
	Private str3 As String
	Private str6 As String
	Private str9 As String
	Private str12 As String
	Private str15 As String
	Private str18 As String
	Private str21 As String
	Private str24 As String
	Private str27 As String
	
	Private intTimeout As Short
	
	Private sngTime As Single
	
	'UPGRADE_NOTE: Class_Initialize was upgraded to Class_Initialize_Renamed. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1061"'
	Private Sub Class_Initialize_Renamed()
		gstrXMLPrefix = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & vbCrLf
		gstrCFRSect = "<CFRSect xmlns:CFRSections=""http://www.oakleaf.ws/CFR/Sections"" >"
		
		strRevDate = "January 1, 2001" 'Temporary default
		
		'Indent strings
		str3 = Space(3)
		str6 = Space(6)
		str9 = Space(9)
		str12 = Space(12)
		str15 = Space(15)
		str18 = Space(18)
		str21 = Space(21)
		str24 = Space(24)
		str27 = Space(27)
	End Sub
	Public Sub New()
		MyBase.New()
		Class_Initialize_Renamed()
	End Sub
	
	Public Function UpdateSectionText(ByVal strConnect As String, ByVal strTitleID As String, ByVal strPartID As String, ByVal strSectID As String, ByVal strAppURL As String, ByVal blnFirstDoc As Boolean) As String
		
		'Retrieves a section from GPO's eCFR, which is updated daily and available in SGML format
		'If successful, returns XML text for display or processing (detected by standard first line)
		'On failure, returns an error message (string), an alternate to Err.Raise
		
		'The original initial URL was "http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&query=7&region=BTI&query=1.3
		'&region=SECTNO&op=AND&query=&region=&op=AND&query=&region=&SORTBY=BIBSRT"
		'which retrieves a page permitting selection of HTML or SGML
		
		'To support hyphenated section numbers, the following initial query is required, which reverses
		'the relative positions of section in the in the query and uses BSEC instead of BSECNO
		'http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&QUERY=19.5-1&RGN=BSEC&OP=and&QUERY=22&RGN=BTI&SUBSET=SUBSET&FROM=1&ITEM=1
		
		'Second URL is http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&SORTBY=%42%49%42%53%52%54
		'&ACTION=ViewNative&QUERY=%37&RGN=%42%54%49&OP=and&QUERY=%31%2E%33&RGN=%53%45%43%54%4E%4F&OP=and
		'&QUERY=&OP=and&QUERY=&OP=and&SUBSET=SUBSET&FROM=1&SIZE=10&ITEM=1
		
		'When the primary database is down, the URL for the backup database is:
		'http://ecfrback.access.gpo.gov/... (The backup database is VERY SLOW.)
		
		'Rather than attempt to generate the second query URL with code, the function retrieves the first page,
		'scrapes it for the URL, and then retrieves the second page with the document text.
		
		Dim rstTest As New ADODB.Recordset
		
		Dim strItem As String
		Dim astrURLs(10) As String
		Dim strURL As String
		Dim strDoc As String
		Dim strXML As String
		Dim strSQL As String
		Dim strMsg As String
		Dim strTemp As String
		
		Static intCtr As Short
		
		Dim lngRecords As Integer
		
		Dim blnParseError As Boolean
		Dim bln2ndPass As Boolean
		Dim blnUseBackupDB As Boolean
		Dim blnIsAppdx As Boolean
		Dim blnDebug As Boolean
		
		On Error GoTo UpdateSectTextErr
		
		UpdateSectionText = ""
		blnDebug = False
		
		If blnFirstDoc Then
			'Retrieve the date of the last update to the beta eCFR for the
			'<Revised>Revised as of ...</Revised> header using WinInet
			'(Currently, the eCFR is several months behind)
			strURL = "http://www.access.gpo.gov/ecfr/"
			strDoc = GetHTMLFromURL(strURL)
			If Len(strDoc) > 500 Then
				If InStr(strDoc, "<!--DATE-->") > 0 Then
					strDoc = Mid(strDoc, InStr(strDoc, "<!--DATE-->") + 11)
					If InStr(strDoc, "<!--/DATE-->") > 0 Then
						strDoc = Left(strDoc, InStr(strDoc, "<!--/DATE-->") - 1)
						strRevDate = ToILC(strDoc)
					Else
						UpdateSectionText = "ERROR: eCFR current date not valid"
					End If
				Else
					UpdateSectionText = "ERROR: eCFR current date not found"
				End If
			Else
				UpdateSectionText = "ERROR: Short eCFR default page (" & CStr(Len(strDoc)) & " chars)"
			End If
		End If
		
		If Len(strAppURL) = 0 Then
			'Get the first page with HTML and SGML Links (below was the original URL"
			'strURL = "http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&"
			'strURL = strURL & "query=" & strTitleID & "&region=BTI&query=" & strPartID & "." & strSectID
			'strURL = strURL & "&region=SECTNO&op=AND&query=&region=&op=AND&query=&region=&SORTBY=BIBSRT"
			
			'New url for normal and hyphenated section numbers
			strURL = "http://ecfr.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&"
			strURL = strURL & "QUERY=" & strPartID & "." & strSectID & "&RGN=BSEC&OP=and&"
			strURL = strURL & "QUERY=" & strTitleID & "&RGN=BTI&SUBSET=SUBSET&FROM=1&ITEM=1"
			blnIsAppdx = False
		Else
			strURL = strAppURL
			blnIsAppdx = True
		End If
		
		sngTime = VB.Timer()
		strDoc = GetHTMLFromURL(strURL)
		System.Windows.Forms.Application.DoEvents()
		
		blnUseBackupDB = False
		If InStr(strDoc, "Application Error") > 0 Or InStr(strDoc, "Internal Server Error") > 0 Then
			'Try the backup database
			'strURL = "http://ecfrback.access.gpo.gov/otcgi/cfr/otfilter.cgi?DB=0&"
			'strURL = strURL & "query=" & strTitleID & "&region=BTI&query=" & strPartID & "." & strSectID
			'strURL = strURL & "&region=SECTNO&op=AND&query=&region=&op=AND&query=&region=&SORTBY=BIBSRT"
			strURL = Replace(strURL, "/ecfr.", "/ecfrback.")
			strDoc = GetHTMLFromURL(strURL)
			blnUseBackupDB = True
		End If
		System.Windows.Forms.Application.DoEvents()
		
		If InStr(strDoc, "Your query produced no results") > 0 Then
			Call UpdateDOCNotFound(strConnect, strTitleID, strPartID, strSectID)
			UpdateSectionText = "ERROR: Query for " & strTitleID & "CFR" & strPartID & "." & strSectID & " produced no results"
			Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
			Exit Function
		End If
		
		If Len(strDoc) < 300 Then
			'Documents as small as about 400 are valie
			sngTime = VB.Timer() - sngTime
			UpdateSectionText = "ERROR: Short document (" & CStr(Len(strDoc)) & " chars)"
			Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
			Exit Function
		End If
		
		If Not blnIsAppdx Then
			'Scrape the first page for the URL to the document
			If InStr(strDoc, "<A HREF=") > 0 Then
				If blnUseBackupDB Then
					strURL = "http://ecfrback.access.gpo.gov"
				Else
					strURL = "http://ecfr.access.gpo.gov"
				End If
				
				'This is the HTML anchor for the query
				'strDoc = Mid$(strDoc, InStr(strDoc, "<A HREF=""/otcgi") + 9)
				
				'Needs testing because appendices may be in a separate doc
				'Only difference between URLs is "View" for HTML and "ViewNative" for SGML
				'strDoc = Mid$(strDoc, InStr(strDoc, "<A HREF=""/otcgi") + 9)
				
				intCtr = 0
				If InStr(strDoc, "<A HREF=""/otcgi") > 0 Then
					Do While InStr(strDoc, "<A HREF=""/otcgi") > 0
						strDoc = Mid(strDoc, InStr(strDoc, "<A HREF=""/otcgi") + 9)
						If intCtr > 8 Then
							Exit Do
						End If
						If InStr(strDoc, ">") > 0 Then
							'Remove the trailing quote and >
							strTemp = Left(strDoc, InStr(strDoc, ">") - 2)
							If InStr(strTemp, "ViewNative") > 0 Then
								'Skip the HTML View
								intCtr = intCtr + 1
								astrURLs(intCtr) = strURL & strTemp
							End If
						Else
							'error
						End If
					Loop 
				End If
				If intCtr > 1 Then
					'For the moment, take the last one
					'Might need to do a compare on the strings; difference is ITEM#
					For intCtr = 1 To 9
						If Len(astrURLs(intCtr)) = 0 Then
							Exit For
						End If
					Next intCtr
					strURL = astrURLs(intCtr - 1)
				Else
					strURL = astrURLs(1)
				End If
			End If
			If InStr(strDoc, ">") > 0 Then
				strDoc = Left(strDoc, InStr(strDoc, ">") - 1)
				strURL = strURL & strDoc
			Else
				'error
			End If
		Else
			'error
		End If
		
		'Repeating the normal retrieval solves almost all parse error problems
		bln2ndPass = False
		Do While True
			If Not blnIsAppdx Then
				'Get the text document
				strDoc = GetHTMLFromURL(strURL)
				System.Windows.Forms.Application.DoEvents()
				sngTime = VB.Timer() - sngTime
				If Len(strDoc) < 300 Then
					'Increment the RetrieveTime value
					Call UpdateDOCNotFound(strConnect, strTitleID, strPartID, strSectID)
					UpdateSectionText = "ERROR: Short CFR document (" & CStr(Len(strDoc)) & " chars)"
					Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
					Exit Function
				End If
				
				If InStr(strDoc, "Your query produced no results") > 0 Or InStr(strDoc, "Application Error: ") > 0 Or InStr(strDoc, "Internal Server Error") > 0 Then
					UpdateSectionText = "Citation " & strTitleID & "CFR" & strPartID & "." & strSectID & " not found"
					If InStr(strDoc, "Application Error: ") > 0 Or InStr(strDoc, "Internal Server Error") > 0 Then
						'The GPO probably has shut down the database
						intCtr = intCtr + 1
					Else
						Call UpdateDOCNotFound(strConnect, strTitleID, strPartID, strSectID)
					End If
					If intCtr > 5 Then
						UpdateSectionText = "ERROR: Halted (GPO probably has shut down the eCFR database)"
						Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
					End If
					Exit Function
				End If
			Else
				
			End If
			'Remove unneeded text and prepare for XML formatting
			If InStr(strDoc, "<BTI>") > 0 Then
				strDoc = Mid(strDoc, InStr(strDoc, "<BTI>"))
				'Structure changed on 9/4/01
				If InStr(strDoc, "</BTI>") = 0 Then
					strDoc = Left(strDoc, InStr(strDoc, "</SECTION>") - 1)
					If InStr(strDoc, "</SECTION>") > 0 Then
						strDoc = Left(strDoc, InStr(strDoc, "</SECTION>") - 1)
					Else
						'error
					End If
				Else
					'error
				End If
			Else
				'error
			End If
			
			If InStr(strDoc, "<RESERVED>[Reserved]") > 0 Then
				'Section is reserved and has no content
				Call UpdateDOCNotFound(strConnect, strTitleID, strPartID, strSectID)
				UpdateSectionText = "ERROR: CFR" & strPartID & "." & strSectID & " is reserved"
				Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
				Exit Function
			End If
			
			If blnDebug Then
				'Save a copy for analysis
				gstrFile = VB6.GetPath & "\Section.txt"
				Err.Clear()
				'UPGRADE_WARNING: Dir has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
				If Len(Dir(gstrFile)) > 0 Then
					Kill(gstrFile)
				End If
				FileOpen(1, gstrFile, OpenMode.Binary)
				'UPGRADE_WARNING: Put was upgraded to FilePut and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
				FilePut(1, strDoc)
				FileClose(1)
			End If
			
			'Format the document
			strXML = ECFRFormatXML(strDoc, strTitleID, strPartID, strSectID, strRevDate, strURL, blnIsAppdx)
			strDoc = ""
			blnParseError = False
			
			If sngTime < 0 Or sngTime > 10000 Then
				'Cover midnight rollover and prevent integer overflow
				sngTime = 6 'Average retrieval time
			End If
			
			'Check for XML parse errors in small documents (50CFR17.95 is 2.5MB!)
			'The SAX parser might have been a better choice, but there are few very long sections
			If Len(strXML) < 500000 Then
				With domDoc
					.loadXML(strXML)
					strTemp = strTitleID & "CFR" & strPartID & "." & strSectID & " (" & CStr(Int(sngTime)) & " seconds)"
					If .parseError.errorCode <> 0 Then
						If .parseError.errorCode = -1072896683 Then
							'Bogus Error: -1072896683, Reason: Only one top level element is allowed in an XML document.
							'However the parser usually doesn't detect other problems at this point
						Else
							blnParseError = True
						End If
					End If
				End With
			End If
			If blnDebug Then
				'Save a text file
				strTemp = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & strXML
				If blnParseError Then
					gstrFile = VB6.GetPath & "\SectionParseError.xml"
				Else
					gstrFile = VB6.GetPath & "\Section.xml"
				End If
				'UPGRADE_WARNING: Dir has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
				If Len(Dir(gstrFile)) > 0 Then
					Kill(gstrFile)
				End If
				FileOpen(1, gstrFile, OpenMode.Binary)
				'UPGRADE_WARNING: Put was upgraded to FilePut and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
				FilePut(1, strTemp)
				FileClose(1)
			End If
			
			With cnnCFR
				If .State = ADODB.ObjectStateEnum.adStateClosed Then
					'Open the connection
					.CommandTimeout = 300
					.Open(strConnect)
					'Define a Command object
					cmmCFR.ActiveConnection = cnnCFR
				End If
			End With
			
			'Check for the presence of the section (might be added during eCFR updates
			With rstTest
				If .State = ADODB.ObjectStateEnum.adStateOpen Then
					.Close()
				End If
			End With
			strSQL = "SELECT HasText FROM Sections "
			strSQL = strSQL & "WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"
			rstTest = cnnCFR.Execute(strSQL,  , ADODB.CommandTypeEnum.adCmdText)
			If rstTest.EOF Then
				'The section is missing, so add a new record
				strSQL = "INSERT Sections(TitleID, PartID, SectionID, HasText) " & "VALUES(" & strTitleID & ", '" & strPartID & "', '" & strSectID & "', 0)"
				With cmmCFR
					.CommandType = ADODB.CommandTypeEnum.adCmdText
					.CommandText = strSQL
					.Execute(lngRecords)
				End With
				If lngRecords = 0 Then
					'Error
					'Stop
				End If
			End If
			rstTest.Close()

            If blnParseError Then
                'Maximum row size is 8060 chars, so leave room for other fields
                strSQL = "UPDATE Sections SET HasText = 0, DocNotFound = 0, ParseError = 1, "
                If Len(strXML) < 7000 Then
                    strSQL = strSQL & "SectChar = '" & Replace(strXML, "'", "''") & "', SectText = NULL "
                Else
                    strSQL = strSQL & "SectText = '" & Replace(strXML, "'", "''") & "', SectChar = NULL "
                End If
            Else
                'Execute the update with ' escaped to '' in text
                strSQL = "UPDATE Sections SET HasText = 1, DateRevised = '" & strRevDate & "', "
                If Len(strXML) < 7000 Then
                    strSQL = strSQL & "SectChar = '" & Replace(strXML, "'", "''") & "', SectText = NULL, "
                Else
                    strSQL = strSQL & "SectText = '" & Replace(strXML, "'", "''") & "', SectChar = NULL, "
                End If
                strSQL = strSQL & "DocNotFound = 0, ParseError = 0, " & "TextLength = " & Len(strXML) & ", RetrieveTime = " & CShort(sngTime) & " "
            End If
            strSQL = strSQL & "WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"

            Err.Clear()
            On Error Resume Next 'Handles timeout errors
            With cmmCFR
                .CommandType = ADODB.CommandTypeEnum.adCmdText
                .CommandText = strSQL
                .Execute(lngRecords)
            End With
            Err.Clear()
            On Error GoTo 0

            If lngRecords = 0 Then
                UpdateSectionText = "ERROR: Database not updated (timeout occurred)"
                Call SaveErrors(strTitleID, strPartID, strSectID, UpdateSectionText)
            End If
            If blnParseError Then
                If bln2ndPass Then
                    'Parse error wasn't corrected
                    With domDoc.parseError
                        strTemp = "ERROR: Parse error in " & strTitleID & "CFR" & strPartID & "." & strSectID & vbCrLf
                        strTemp = strTemp & "       Error: " & CStr(.errorCode) & ", Reason: " & .reason & ", Line: " & CStr(.line) & ", Position: " & CStr(.linepos) & vbCrLf
                        strXML = strTemp & strXML
                    End With
                    Call SaveErrors(strTitleID, strPartID, strSectID, strTemp)
                    Exit Do
                End If
                bln2ndPass = True
                sngTime = VB.Timer()
            Else
                Exit Do
            End If
        Loop
		
		UpdateSectionText = strXML
		GoTo UpdateSectTextExit
		
UpdateSectTextErr: 
		UpdateSectionText = "ERROR: " & Err.Description & " (" & CStr(Err.Number) & ")"
		GoTo UpdateSectTextExit
		
UpdateSectTextExit: 
        With cnnCFR
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
    End Function

    Private Sub UpdateDOCNotFound(ByVal strConnect As String, ByVal strTitleID As String, ByVal strPartID As String, ByVal strSectID As String)

        'Update the Sections database
        Dim strSQL As String
        With cnnCFR
            If .State = ADODB.ObjectStateEnum.adStateClosed Then
                'Open the connection
                .CommandTimeout = 300
                .Open(strConnect)
                'Define a Command object
                cmmCFR.ActiveConnection = cnnCFR
            End If
        End With
        sngTime = VB.Timer() - sngTime
        If sngTime < 0 Or sngTime > 10000 Then
            'Cover midnight rollover and prevent integer overflow
            sngTime = 6 'Average retrieval time
        End If
        strSQL = "UPDATE Sections SET HasText = 0, RetrieveTime = RetrieveTime + " & CStr(Int(sngTime)) & ", Retries = Retries + 1, DocNotFound = 1 WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectID & "'"
        With cmmCFR
            .CommandType = ADODB.CommandTypeEnum.adCmdText
            .CommandText = strSQL
            .Execute()
        End With
        Call SaveErrors(strTitleID, strPartID, strSectID, "ERROR: ECFR Document not found.")
    End Sub

    Private Sub SaveErrors(ByVal strTitleID As String, ByVal strPartID As String, ByVal strSectID As String, ByVal strErr As String)
        Dim strFile As String
        Dim strErrors As String

        strFile = VB6.GetPath & "\GetSectErrors.txt"

        FileOpen(1, strFile, OpenMode.Binary)
        'UPGRADE_WARNING: Dir has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
        If Len(Dir(strFile)) > 0 Then
            If FileLen(strFile) > 0 Then
                strErrors = Space(FileLen(strFile))
                'UPGRADE_WARNING: Get was upgraded to FileGet and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
                FileGet(1, strErrors)
                FileClose(1)
                Kill(strFile)
                FileOpen(1, strFile, OpenMode.Binary)
            Else
                strErrors = ""
            End If
        End If
        'The above maneuver and this put the last error first
        strErrors = Now & " - " & strTitleID & "CFR" & strPartID & "." & strSectID & " - " & strErr & vbCrLf & strErrors
        'UPGRADE_WARNING: Put was upgraded to FilePut and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
        FilePut(1, strErrors)
        FileClose(1)
    End Sub


    Private Function ECFRFormatXML(ByVal strDoc As String, ByVal strTitleID As String, ByVal strPartID As String, ByVal strSectID As String, ByVal strRevDate As String, ByVal strURL As String, ByVal blnIsAppdx As Boolean) As String

        'Format the flat eCFR SGML document as a structured XML document
        Dim strXML As String
        Dim strFind As String
        Dim strSub As String
        Dim strEnd As String
        Dim strText As String
        Dim strLastText As String
        Dim strTag As String
        Dim strType As String
        Dim strPref As String
        Dim strChar As String
        Dim strFedReg As String
        Dim strEndNote As String
        Dim strExt As String
        Dim strLastSubPara As String
        Dim strTemp As String

        Dim intCtr As Short
        Dim intChar As Short
        Dim intLevel As Short
        Dim intLastLevel As Short
        Dim intNewLevel As Short
        Dim intType As Short
        Dim intSp As Short

        Dim blnIsBody As Boolean
        Dim blnBogusPara As Boolean
        Dim blnFirstHead As Boolean
        Dim blnHasHead As Boolean
        Dim blnStop As Boolean 'Temporary for test

        'Temporary, remove for production
        Dim varShell As Object

        strEndNote = ""

        strTemp = "<!---------------------------- END OF SGML"
        If InStr(strDoc, strTemp) > 0 Then
            'Remove the trailing content
            strDoc = Left(strDoc, InStr(strDoc, strTemp) - 1)
        End If

        'Following is the HTML URL for opening pages with tables or documents
        'that won't convert to well-formed XML
        strURL = "<![CDATA[" & Replace(strURL, "ViewNative", "View") & "]]>"
        'Temporary for test (" detected in 7CFR29.2438)
        strURL = Replace(strURL, Chr(34), "")
        'Use the HTML database
        strURL = Replace(strURL, "?DB=0&", "?DB=1&")

        'Remove <PRE> and flag removed in endnotes
        'There is no practical method for munging tables to XML
        intCtr = 1
        If InStr(strDoc, "<PRE>") > 0 Then
            Do While InStr(strDoc, "<PRE>") > 0 And InStr(strDoc, "</PRE>") > 0
                If InStr(strDoc, "</PRE>") > 0 Then
                    strTemp = Mid(strDoc, InStr(strDoc, "</PRE>") + 6)
                    strDoc = Left(strDoc, InStr(strDoc, "<PRE>") - 1)
                    strDoc = strDoc & strTemp
                    If intCtr = 1 Then
                        strEndNote = strEndNote & Space(6) & "<Para1>" & vbCrLf
                        strEndNote = strEndNote & Space(9) & "Preformatted HTML table(s) removed" & vbCrLf
                        strEndNote = strEndNote & Space(9) & "<URL>" & vbCrLf & Space(12) & Replace(strURL, "ecfrback", "ecfr") & vbCrLf & Space(9) & "</URL>" & vbCrLf
                        strEndNote = strEndNote & Space(6) & "</Para1>" & vbCrLf
                    End If
                    intCtr = intCtr + 1
                    'Safety net for continuous loop
                    If intCtr > 100 Then
                        Exit Do
                    End If
                Else
                    'error
                    Exit Do
                End If
            Loop
        End If

        'Remove <GPOTABLE> and flag removed in endnotes
        intCtr = 1
        If InStr(strDoc, "<GPOTABLE") > 0 Then
            Do While InStr(strDoc, "<GPOTABLE") > 0 And InStr(strDoc, "</GPOTABLE>") > 0
                If InStr(strDoc, "</GPOTABLE>") > 0 Then
                    strTemp = Mid(strDoc, InStr(strDoc, "</GPOTABLE>") + 11)
                    strDoc = Left(strDoc, InStr(strDoc, "<GPOTABLE") - 1)
                    strDoc = strDoc & strTemp
                    If intCtr = 1 Then
                        strEndNote = strEndNote & Space(6) & "<Para1>" & vbCrLf
                        strEndNote = strEndNote & Space(9) & "GPO table(s) removed" & vbCrLf
                        If InStr(strEndNote, "<URL>") = 0 Then
                            strEndNote = strEndNote & Space(9) & "<URL>" & vbCrLf & Space(12) & Replace(strURL, "ecfrback", "ecfr") & vbCrLf & Space(9) & "</URL>" & vbCrLf
                        End If
                        strEndNote = strEndNote & Space(6) & "</Para1>" & vbCrLf
                    End If
                    intCtr = intCtr + 1
                    If intCtr > 50 Then
                        Exit Do
                    End If
                Else
                    'error
                    Exit Do
                End If
            Loop
        End If

        'Delete <MATH> and flag removed
        intCtr = 1
        If InStr(strDoc, "<MATH") > 0 Then
            Do While InStr(strDoc, "<MATH") > 0
                If InStr(strDoc, "</MATH>") > 0 Then
                    strTemp = Mid(strDoc, InStr(strDoc, "</MATH>") + 7)
                    strDoc = Left(strDoc, InStr(strDoc, "<MATH") - 1)
                    strDoc = strDoc & strTemp
                    If intCtr = 1 Then
                        strEndNote = strEndNote & Space(6) & "<Para1>" & vbCrLf
                        strEndNote = strEndNote & Space(9) & "Mathematic element(s) removed" & vbCrLf
                        If InStr(strEndNote, "<URL>") = 0 Then
                            strEndNote = strEndNote & Space(9) & "<URL>" & vbCrLf & Space(12) & Replace(strURL, "ecfrback", "ecfr") & vbCrLf & Space(9) & "</URL>" & vbCrLf
                        End If
                        strEndNote = strEndNote & Space(6) & "</Para1>" & vbCrLf
                    End If
                    intCtr = intCtr + 1
                Else
                    'error
                    Exit Do
                End If
            Loop
        End If

        'Remove <GPH header, but don't flag removed
        intCtr = 1
        If InStr(strDoc, "<GPH") > 0 Then
            Do While InStr(strDoc, "<GPH") > 0
                If InStr(strDoc, "</GPH>") > 0 Then
                    strTemp = Mid(strDoc, InStr(strDoc, "</GPH>") + 6)
                    strDoc = Left(strDoc, InStr(strDoc, "<GPH") - 1)
                    strDoc = strDoc & strTemp
                    intCtr = intCtr + 1
                Else
                    'error
                    Exit Do
                End If
            Loop
        End If

        'Remove literals (SGML character references) and SGML formatting tags in groups
        'The complete entity list for the Federal Register is at
        'http://www.access.gpo.gov/ecfr/gpospl1.txt

        'All XML/XHTML 1.0 entities, plus special SGML character references from e-CFR
        'All ISO entities added to assure conformance with future e-CFR text
        'An asterisk (*) in the comment indicates a special Federal Register entity

        'Portions (C) International Organization for Standardization 1986
        'Permission to copy in any form is granted for use with
        'conforming SGML systems and applications as defined in
        'ISO 8879, provided this notice is included in all copies.
        strDoc = Replace(strDoc, "&Aacute;", "&#193;") 'Latin capital letter A with acute
        strDoc = Replace(strDoc, "&aacute;", "&#225;") 'Latin small letter a with acute
        strDoc = Replace(strDoc, "&Acirc;", "&#194;") 'Latin capital letter A with circumflex
        strDoc = Replace(strDoc, "&acirc;", "&#226;") 'Latin small letter a with circumflex
        strDoc = Replace(strDoc, "&acute;", "&#180;") 'acute accent = spacing acute
        strDoc = Replace(strDoc, "&AElig;", "&#198;") 'Latin capital letter AE
        strDoc = Replace(strDoc, "&aelig;", "&#230;") 'Latin small letter ae
        strDoc = Replace(strDoc, "&Agrave;", "&#192;") 'Latin capital letter A with grave
        strDoc = Replace(strDoc, "&agrave;", "&#224;") 'Latin small letter a with grave
        strDoc = Replace(strDoc, "&alefsym;", "&#8501;") 'alef symbol = first transfinite cardinal
        strDoc = Replace(strDoc, "&Alpha;", "&#913;") 'Greek capital letter alpha
        strDoc = Replace(strDoc, "&alpha;", "&#945;") 'Greek small letter alpha
        strDoc = Replace(strDoc, "&amp;", "&#38;") 'ampersand
        strDoc = Replace(strDoc, "&and;", "&#8743;") 'logical and = wedge
        strDoc = Replace(strDoc, "&ang;", "&#8736;") 'angle
        strDoc = Replace(strDoc, "&ap;", "'") 'Infrequent use*
        strDoc = Replace(strDoc, "&apos;", "&#39;") 'apostrophe mark
        strDoc = Replace(strDoc, "&Aring;", "&#197;") 'Latin capital letter A with ring above
        strDoc = Replace(strDoc, "&aring;", "&#229;") 'Latin small letter a with ring above
        strDoc = Replace(strDoc, "&ast;", "*") 'Unknown why the literal is used*
        strDoc = Replace(strDoc, "&asymp;", "&#8776;") 'almost equal to = asymptotic to
        strDoc = Replace(strDoc, "&Atilde;", "&#195;") 'Latin capital letter A with tilde
        strDoc = Replace(strDoc, "&atilde;", "&#227;") 'Latin small letter a with tilde
        strDoc = Replace(strDoc, "&Auml;", "&#196;") 'Latin capital letter A with diaeresis
        strDoc = Replace(strDoc, "&auml;", "&#228;") 'Latin small letter a with diaeresis
        strDoc = Replace(strDoc, "&bddarr;", "&#8595;") 'Bold down arrow *
        strDoc = Replace(strDoc, "&bdlarr;", "&#8592;") 'Bold left arrow *
        strDoc = Replace(strDoc, "&bdquo;", "&#8222;") 'double low-9 quotation mark
        strDoc = Replace(strDoc, "&bdrarr;", "&#8594;") 'Bold right arrow *
        strDoc = Replace(strDoc, "&bduarr;", "&#8593;") 'Bold up arrow
        strDoc = Replace(strDoc, "&Beta;", "&#914;") 'Greek capital letter beta
        strDoc = Replace(strDoc, "&beta;", "&#946;") 'Greek small letter beta
        strDoc = Replace(strDoc, "&bgr;", "&#946") '*
        strDoc = Replace(strDoc, "&Bgr;", "&#914;") 'Another version *
        strDoc = Replace(strDoc, "&bond;", "(bond entity)") 'Unlisted entity *
        strDoc = Replace(strDoc, "&brvbar;", "&#166;") 'broken bar
        strDoc = Replace(strDoc, "&bsol;", "") 'Light backward shill(??)
        strDoc = Replace(strDoc, "&bsolb;", "") 'Bold one
        strDoc = Replace(strDoc, "&bull;", "&#8226;") 'bullet = black small circle
        strDoc = Replace(strDoc, "&cap;", "&#8745;") 'intersection = cap
        strDoc = Replace(strDoc, "&ccedil;", "") 'For Portogese (in cao, "c" precedes)
        strDoc = Replace(strDoc, "&Ccedil;", "&#199;") 'Latin capital letter C with cedilla
        strDoc = Replace(strDoc, "&ccedil;", "&#231;") 'Latin small letter c with cedilla
        strDoc = Replace(strDoc, "&cedil;", "&#184;") 'cedilla = spacing cedilla
        strDoc = Replace(strDoc, "&cent;", "&#162;") 'cent sign
        strDoc = Replace(strDoc, "&Chi;", "&#935;") 'Greek capital letter chi
        strDoc = Replace(strDoc, "&chi;", "&#967;") 'Greek small letter chi
        strDoc = Replace(strDoc, "&circ;", "&#710;") 'modifier letter circumflex accent
        strDoc = Replace(strDoc, "&clubs;", "&#9827;") 'black club suit = shamrock
        strDoc = Replace(strDoc, "&commat;", "@") '*
        strDoc = Replace(strDoc, "&cong;", "&#8773;") 'approximately equal to
        strDoc = Replace(strDoc, "&copy;", "&#169;") 'copyright sign
        strDoc = Replace(strDoc, "&crarr;", "&#8629;") 'downwards arrow with corner leftwards
        strDoc = Replace(strDoc, "&cup;", "&#8746;") 'union = cup
        strDoc = Replace(strDoc, "&curren;", "&#164;") 'currency sign
        strDoc = Replace(strDoc, "&dagger;", "&#8224;") 'dagger
        strDoc = Replace(strDoc, "&Dagger;", "&#8225;") 'double dagger
        strDoc = Replace(strDoc, "&darr;", "&#8595;") 'downwards arrow
        strDoc = Replace(strDoc, "&dArr;", "&#8659;") 'downwards double arrow
        strDoc = Replace(strDoc, "&deg;", "&#176;") 'degree sign
        strDoc = Replace(strDoc, "&Delta;", "&#916;") 'Greek capital letter delta
        strDoc = Replace(strDoc, "&delta;", "&#948;") 'Greek small letter delta
        strDoc = Replace(strDoc, "&diams;", "&#9830;") 'black diamond suit
        strDoc = Replace(strDoc, "&divide;", "&#247;") 'division sign
        strDoc = Replace(strDoc, "&dollar;", "$")
        strDoc = Replace(strDoc, "&dprime;", "''") 'For chemicals (exact replacements)
        strDoc = Replace(strDoc, "&Eacute;", "&#201;") 'Latin capital letter E with acute
        strDoc = Replace(strDoc, "&eacute;", "&#233;") 'Latin small letter e with acute
        strDoc = Replace(strDoc, "&Ecirc;", "&#202;") 'Latin capital letter E with circumflex
        strDoc = Replace(strDoc, "&ecirc;", "&#234;") 'Latin small letter e with circumflex
        strDoc = Replace(strDoc, "&Egrave;", "&#200;") 'Latin capital letter E with grave
        strDoc = Replace(strDoc, "&egrave;", "&#232;") 'Latin small letter e with grave
        strDoc = Replace(strDoc, "&ell;", "l") 'Unlisted entity, used in liters/min, no clue as to why an entity *
        strDoc = Replace(strDoc, "&empty;", "&#8709;") 'empty set = null set = diameter
        strDoc = Replace(strDoc, "&emsp;", "&#8195;") 'em space
        strDoc = Replace(strDoc, "&ensp;", "&#8194;") 'en space
        strDoc = Replace(strDoc, "&Epsilon;", "&#917;") 'Greek capital letter epsilon
        strDoc = Replace(strDoc, "&epsilon;", "&#949;") 'Greek small letter epsilon
        strDoc = Replace(strDoc, "&epsiv;", "&#949;") ' *
        strDoc = Replace(strDoc, "&equal;", "=") ' *
        strDoc = Replace(strDoc, "&equals;", "=") ' *
        strDoc = Replace(strDoc, "&equiv;", "&#8801;") 'identical to
        strDoc = Replace(strDoc, "&Eta;", "&#919;") 'Greek capital letter eta
        strDoc = Replace(strDoc, "&eta;", "&#951;") 'Greek small letter eta
        strDoc = Replace(strDoc, "&ETH;", "&#208;") 'Latin capital letter ETH
        strDoc = Replace(strDoc, "&eth;", "&#240;") 'Latin small letter eth
        strDoc = Replace(strDoc, "&Euml;", "&#203;") 'Latin capital letter E with diaeresis
        strDoc = Replace(strDoc, "&euml;", "&#235;") 'Latin small letter e with diaeresis
        strDoc = Replace(strDoc, "&euro;", "&#8364;") 'euro sign
        strDoc = Replace(strDoc, "&exist;", "&#8707;") 'there exists
        strDoc = Replace(strDoc, "&fnof;", "&#402;") 'Latin small f with hook = function
        strDoc = Replace(strDoc, "&foot;", " ft.") '*
        strDoc = Replace(strDoc, "&forall;", "&#8704;") 'for all
        strDoc = Replace(strDoc, "&frac12;", "&#189;") 'vulgar fraction one half
        strDoc = Replace(strDoc, "&frac14;", "&#188;") 'vulgar fraction one quarter
        strDoc = Replace(strDoc, "&frac34;", "&#190;") 'vulgar fraction three quarters
        strDoc = Replace(strDoc, "&frasl;", "&#8260;") 'fraction slash
        strDoc = Replace(strDoc, "&Gamma;", "&#915;") 'Greek capital letter gamma
        strDoc = Replace(strDoc, "&gamma;", "&#947;") 'Greek small letter gamma
        strDoc = Replace(strDoc, "&ge;", "&#8805;") 'greater-than or equal to
        strDoc = Replace(strDoc, "&gE;", "&#8805;") ' *
        strDoc = Replace(strDoc, "&ge2;", "&#8805;") ' *
        strDoc = Replace(strDoc, "&gt;", "&#62;") 'greater-than sign
        strDoc = Replace(strDoc, "&Gt;", "&#62;&#62;") ' *
        strDoc = Replace(strDoc, "&gteqt;", "&#8805;") ' *
        strDoc = Replace(strDoc, "&gtl;", "&#62;&#60;") ' *
        strDoc = Replace(strDoc, "&hairsp;", "")
        strDoc = Replace(strDoc, "&half;", "'1/2' entity") 'Not in list, and doesn't appear to be 1/2
        strDoc = Replace(strDoc, "&harr;", "&#8596;") 'left right arrow
        strDoc = Replace(strDoc, "&hArr;", "&#8660;") 'left right double arrow
        strDoc = Replace(strDoc, "&hearts;", "&#9829;") 'black heart suit = valentine
        strDoc = Replace(strDoc, "&hellip;", "&#8230;") 'horizontal ellipsis = three dot leader
        strDoc = Replace(strDoc, "&hyphen;", "-") ' *
        strDoc = Replace(strDoc, "&Iacute;", "&#205;") 'Latin capital letter I with acute
        strDoc = Replace(strDoc, "&iacute;", "&#237;") 'Latin small letter i with acute
        strDoc = Replace(strDoc, "&Icirc;", "&#206;") 'Latin capital letter I with circumflex
        strDoc = Replace(strDoc, "&icirc;", "&#238;") 'Latin small letter i with circumflex
        strDoc = Replace(strDoc, "&iexcl;", "&#161;") 'inverted exclamation mark
        strDoc = Replace(strDoc, "&Igrave;", "&#204;") 'Latin capital letter I with grave
        strDoc = Replace(strDoc, "&igrave;", "&#236;") 'Latin small letter i with grave
        strDoc = Replace(strDoc, "&image;", "&#8465;") 'blackletter capital I = imaginary part
        strDoc = Replace(strDoc, "&inch;", " in.")
        strDoc = Replace(strDoc, "&infin;", "&#8734;") 'infinity
        strDoc = Replace(strDoc, "&int;", "&#8747;") 'integral
        strDoc = Replace(strDoc, "&Iota;", "&#921;") 'Greek capital letter iota
        strDoc = Replace(strDoc, "&iota;", "&#953;") 'Greek small letter iota
        strDoc = Replace(strDoc, "&iquest;", "&#191;") 'inverted question mark
        strDoc = Replace(strDoc, "&isin;", "&#8712;") 'element of
        strDoc = Replace(strDoc, "&Iuml;", "&#207;") 'Latin capital letter I with diaeresis
        strDoc = Replace(strDoc, "&iuml;", "&#239;") 'Latin small letter i with diaeresis
        strDoc = Replace(strDoc, "&Kappa;", "&#922;") 'Greek capital letter kappa
        strDoc = Replace(strDoc, "&kappa;", "&#954;") 'Greek small letter kappa
        strDoc = Replace(strDoc, "&KHgr;", "&#935;") 'Why KH? *
        strDoc = Replace(strDoc, "&Lambda;", "&#923;") 'Greek capital letter lambda
        strDoc = Replace(strDoc, "&lambda;", "&#955;") 'Greek small letter lambda
        strDoc = Replace(strDoc, "&lang;", "&#9001;") 'left-pointing angle bracket = bra
        strDoc = Replace(strDoc, "&laquo;", "&#171;") 'left-pointing double angle quotation mark
        strDoc = Replace(strDoc, "&larr;", "&#8592;") 'leftwards arrow
        strDoc = Replace(strDoc, "&lArr;", "&#8656;") 'leftwards double arrow
        strDoc = Replace(strDoc, "&lceil;", "&#8968;") 'left ceiling = apl upstile
        strDoc = Replace(strDoc, "&lcub;", "{") ' *
        strDoc = Replace(strDoc, "&ldquo;", "&#8220;") 'left double quotation mark
        strDoc = Replace(strDoc, "&le;", "&#8804;") 'less-than or equal to
        strDoc = Replace(strDoc, "&lE;", "&#8804;") ' *
        strDoc = Replace(strDoc, "&le2;", "&#8804;") ' *
        strDoc = Replace(strDoc, "&lfloor;", "&#8970;") 'left floor = apl downstile
        strDoc = Replace(strDoc, "&lgr;", "&#955;") 'irregular
        strDoc = Replace(strDoc, "&lowast;", "&#8727;") 'asterisk operator
        strDoc = Replace(strDoc, "&lowbar;", "_") 'Uncommon *
        strDoc = Replace(strDoc, "&lowbarm;", "_") ' *
        strDoc = Replace(strDoc, "&loz;", "&#9674;") 'lozenge
        strDoc = Replace(strDoc, "&lpar;", "&#182;") 'Paragraph symbol *
        strDoc = Replace(strDoc, "&lrm;", "&#8206;") 'left-to-right mark
        strDoc = Replace(strDoc, "&lsaquo;", "&#8249;") 'single left-pointing angle quotation mark
        strDoc = Replace(strDoc, "&lsqb;", "[") 'Very uncommon *
        strDoc = Replace(strDoc, "&lsqbb;", "[") 'More uncommon (bold) *
        strDoc = Replace(strDoc, "&lsquo;", "&#8216;") 'left single quotation mark
        strDoc = Replace(strDoc, "&lt;", "&#60;") 'less-than sign
        strDoc = Replace(strDoc, "&Lt;", "&#60;&#60;") ' *
        strDoc = Replace(strDoc, "&lteqt;", "&#8804;") ' *
        strDoc = Replace(strDoc, "&ltg;", "&#60; &#62;")
        strDoc = Replace(strDoc, "&lthneq2", "&#8804;!=") ' *
        strDoc = Replace(strDoc, "&macr;", "&#175;") 'macron = spacing macron = overline
        strDoc = Replace(strDoc, "&mdash;", "&#8212;") 'em dash
        strDoc = Replace(strDoc, "&mgr;", "&#62;&#62;") ' *
        strDoc = Replace(strDoc, "&mgt;", "&#62;&#62;") ' *
        strDoc = Replace(strDoc, "&micro;", "&#181;") 'micro sign
        strDoc = Replace(strDoc, "&middot;", "&#183;") 'middle dot = Georgian comma
        strDoc = Replace(strDoc, "&min;", "'") ' *
        strDoc = Replace(strDoc, "&minus;", "&#8722;") 'minus sign
        strDoc = Replace(strDoc, "&mlt;", "&#60;&#60;") ' *
        strDoc = Replace(strDoc, "&mnplus;", "-/+") 'Don't see this very often *
        strDoc = Replace(strDoc, "&Mu;", "&#924;") 'Greek capital letter mu
        strDoc = Replace(strDoc, "&mu;", "&#956;") 'Greek small letter mu
        strDoc = Replace(strDoc, "&nabla;", "&#8711;") 'nabla = backward difference
        strDoc = Replace(strDoc, "&nbsp;", "&#160;") 'no-break space = non-breaking space
        strDoc = Replace(strDoc, "&ndash;", "&#8211;") 'en dash
        strDoc = Replace(strDoc, "&ne;", "&#8800;") 'not equal to
        strDoc = Replace(strDoc, "&ni;", "&#8715;") 'contains as member
        strDoc = Replace(strDoc, "&not;", "&#172;") 'not sign = discretionary hyphen
        strDoc = Replace(strDoc, "&notin;", "&#8713;") 'not an element of
        strDoc = Replace(strDoc, "&nsub;", "&#8836;") 'not a subset of
        strDoc = Replace(strDoc, "&Ntilde;", "&#209;") 'Latin capital letter N with tilde
        strDoc = Replace(strDoc, "&ntilde;", "&#241;") 'Latin small letter n with tilde
        strDoc = Replace(strDoc, "&Nu;", "&#925;") 'Greek capital letter nu
        strDoc = Replace(strDoc, "&nu;", "&#957;") 'Greek small letter nu
        strDoc = Replace(strDoc, "&num;", "#") ' *
        strDoc = Replace(strDoc, "&Oacute;", "&#211;") 'Latin capital letter O with acute
        strDoc = Replace(strDoc, "&oacute;", "&#243;") 'Latin small letter o with acute
        strDoc = Replace(strDoc, "&Ocirc;", "&#212;") 'Latin capital letter O with circumflex
        strDoc = Replace(strDoc, "&ocirc;", "&#244;") 'Latin small letter o with circumflex
        strDoc = Replace(strDoc, "&OElig;", "&#338;") 'Latin capital ligature OE
        strDoc = Replace(strDoc, "&oelig;", "&#339;") 'Latin small ligature oe
        strDoc = Replace(strDoc, "&Ogr;", "&#937;") ' *
        strDoc = Replace(strDoc, "&ogr;", "&#969;") ' *
        strDoc = Replace(strDoc, "&Ograve;", "&#210;") 'Latin capital letter O with grave
        strDoc = Replace(strDoc, "&ograve;", "&#242;") 'Latin small letter o with grave
        strDoc = Replace(strDoc, "&ohm;", "&#937;") 'as in Omega *
        strDoc = Replace(strDoc, "&oline;", "&#8254;") 'overline = spacing overscore
        strDoc = Replace(strDoc, "&om;", "M") 'M in a circle for mask copyrights *
        strDoc = Replace(strDoc, "&Omega;", "&#937;") 'Greek capital letter omega
        strDoc = Replace(strDoc, "&omega;", "&#969;") 'Greek small letter omega
        strDoc = Replace(strDoc, "&Omicron;", "&#927;") 'Greek capital letter omicron
        strDoc = Replace(strDoc, "&omicron;", "&#959;") 'Greek small letter omicron
        strDoc = Replace(strDoc, "&oplus;", "&#8853;") 'circled plus = direct sum
        strDoc = Replace(strDoc, "&or;", "&#8744;") 'logical or = vee
        strDoc = Replace(strDoc, "&ordf;", "&#170;") 'feminine ordinal indicator
        strDoc = Replace(strDoc, "&ordm;", "&#186;") 'masculine ordinal indicator
        strDoc = Replace(strDoc, "&Oslash;", "&#216;") 'Latin capital letter O with stroke
        strDoc = Replace(strDoc, "&oslash;", "&#248;") 'Latin small letter o with stroke
        strDoc = Replace(strDoc, "&Otilde;", "&#213;") 'Latin capital letter O with tilde
        strDoc = Replace(strDoc, "&otilde;", "&#245;") 'Latin small letter o with tilde
        strDoc = Replace(strDoc, "&otimes;", "&#8855;") 'circled times = vector product
        strDoc = Replace(strDoc, "&Ouml;", "&#214;") 'Latin capital letter O with diaeresis
        strDoc = Replace(strDoc, "&ouml;", "&#246;") 'Latin small letter o with diaeresis
        strDoc = Replace(strDoc, "&par;", "('par' entity)")
        strDoc = Replace(strDoc, "&para;", "&#182;") 'pilcrow sign = paragraph sign
        strDoc = Replace(strDoc, "&part;", "&#8706;") 'partial differential
        strDoc = Replace(strDoc, "&permil;", "&#8240;") 'per mille sign
        strDoc = Replace(strDoc, "&perp;", "&#8869;") 'up tack = orthogonal to = perpendicular
        strDoc = Replace(strDoc, "&Phi;", "&#934;") 'Greek capital letter phi
        strDoc = Replace(strDoc, "&phi;", "&#966;") 'Greek small letter phi
        strDoc = Replace(strDoc, "&phis;", "(phis entity)") 'Unlisted entity *
        strDoc = Replace(strDoc, "&Pi;", "&#928;") 'Greek capital letter pi
        strDoc = Replace(strDoc, "&pi;", "&#960;") 'Greek small letter pi
        strDoc = Replace(strDoc, "&piv;", "&#982;") 'Greek pi symbol
        strDoc = Replace(strDoc, "&plus;", "+") ' *
        strDoc = Replace(strDoc, "&plusmn;", "&#177;") 'plus-minus sign = plus-or-minus sign
        strDoc = Replace(strDoc, "&pound;", "&#163;") 'pound sign
        strDoc = Replace(strDoc, "&prime;", "&#8242;") 'prime = minutes = feet
        strDoc = Replace(strDoc, "&Prime;", "&#8243;") 'double prime = seconds = inches
        strDoc = Replace(strDoc, "&prod;", "&#8719;") 'n-ary product = product sign
        strDoc = Replace(strDoc, "&prop;", "&#8733;") 'proportional to
        strDoc = Replace(strDoc, "&Psi;", "&#936;") 'Greek capital letter psi
        strDoc = Replace(strDoc, "&psi;", "&#968;") 'Greek small letter psi
        strDoc = Replace(strDoc, "&qdrt;", "QdRt")
        strDoc = Replace(strDoc, "&quot;", "&#34;") 'quotation mark = APL quote
        strDoc = Replace(strDoc, "&radic;", "&#8730;") 'square root = radical sign
        strDoc = Replace(strDoc, "&radic;", "SqRt") 'Need MathML for radical signs
        strDoc = Replace(strDoc, "&rang;", "&#9002;") 'right-pointing angle bracket = ket
        strDoc = Replace(strDoc, "&raquo;", "&#187;") 'right-pointing double angle quotation mark
        strDoc = Replace(strDoc, "&rarr;", "&#8594;") 'rightwards arrow
        strDoc = Replace(strDoc, "&rArr;", "&#8658;") 'rightwards double arrow
        strDoc = Replace(strDoc, "&rceil;", "&#8969;") 'right ceiling
        strDoc = Replace(strDoc, "&rcub;", "}") ' *
        strDoc = Replace(strDoc, "&rdquo;", "&#8221;") 'right double quotation mark
        strDoc = Replace(strDoc, "&real;", "&#8476;") 'blackletter capital R = real part symbol
        strDoc = Replace(strDoc, "&reg;", "&#174;") 'registered sign = registered trade mark sign
        strDoc = Replace(strDoc, "&rfloor;", "&#8971;") 'right floor
        strDoc = Replace(strDoc, "&Rho;", "&#929;") 'Greek capital letter rho
        strDoc = Replace(strDoc, "&rho;", "&#961;") 'Greek small letter rho
        strDoc = Replace(strDoc, "&rlm;", "&#8207;") 'right-to-left mark
        strDoc = Replace(strDoc, "&rpar;", "") ' *
        strDoc = Replace(strDoc, "&rsaquo;", "&#8250;") 'single right-pointing angle quotation mark
        strDoc = Replace(strDoc, "&rsqb;", "]") ' *
        strDoc = Replace(strDoc, "&rsqbb;", "]") ' *
        strDoc = Replace(strDoc, "&rsquo;", "&#8217;") 'right single quotation mark
        strDoc = Replace(strDoc, "&sbquo;", "&#8218;") 'single low-9 quotation mark
        strDoc = Replace(strDoc, "&sbull;", "*")
        strDoc = Replace(strDoc, "&Scaron;", "&#352;") 'Latin capital letter S with caron
        strDoc = Replace(strDoc, "&scaron;", "&#353;") 'Latin small letter s with caron
        strDoc = Replace(strDoc, "&sdot;", "&#8901;") 'dot operator
        strDoc = Replace(strDoc, "&sec;", "''") 'Latitude and longitude
        strDoc = Replace(strDoc, "&sect;", "&#167;") 'section sign
        strDoc = Replace(strDoc, "&shy;", "&#173;") 'soft hyphen = discretionary hyphen
        strDoc = Replace(strDoc, "&Sigma;", "&#931;") 'Greek capital letter sigma
        strDoc = Replace(strDoc, "&sigma;", "&#963;") 'Greek small letter sigma
        strDoc = Replace(strDoc, "&sigmaf;", "&#962;") 'Greek small letter final sigma
        strDoc = Replace(strDoc, "&sim;", "&#8764;") 'tilde operator = varies with = similar to
        strDoc = Replace(strDoc, "&sol;", "/") 'Questionable (used in soluble extracts, not in list) *
        strDoc = Replace(strDoc, "&spades;", "&#9824;") 'black spade suit
        strDoc = Replace(strDoc, "&sqrt;", "SqRt") ' *
        strDoc = Replace(strDoc, "&squ;", "[ ]") 'Sort of a square
        strDoc = Replace(strDoc, "&sub;", "&#8834;") 'subset of
        strDoc = Replace(strDoc, "&sube;", "&#8838;") 'subset of or equal to
        strDoc = Replace(strDoc, "&sum;", "&#8721;") 'n-ary sumation
        strDoc = Replace(strDoc, "&sup;", "&#8835;") 'superset of
        strDoc = Replace(strDoc, "&sup1;", "&#185;") 'superscript one = superscript digit one
        strDoc = Replace(strDoc, "&sup2;", "&#178;") 'superscript two = superscript digit two
        strDoc = Replace(strDoc, "&sup3;", "&#179;") 'superscript three = superscript digit three
        strDoc = Replace(strDoc, "&supe;", "&#8839;") 'superset of or equal to
        strDoc = Replace(strDoc, "&szlig;", "&#223;") 'Latin small letter sharp s = ess-zed
        strDoc = Replace(strDoc, "&Tau;", "&#932;") 'Greek capital letter tau
        strDoc = Replace(strDoc, "&tau;", "&#964;") 'Greek small letter tau
        strDoc = Replace(strDoc, "&there4;", "&#8756;") 'therefore
        strDoc = Replace(strDoc, "&Theta;", "&#920;") 'Greek capital letter theta
        strDoc = Replace(strDoc, "&theta;", "&#952;") 'Greek small letter theta
        strDoc = Replace(strDoc, "&thetas;", "&#952;") 'irregular *
        strDoc = Replace(strDoc, "&thetasym;", "&#977;") 'Greek small letter theta symbol
        strDoc = Replace(strDoc, "&thinsp;", "&#8201;") 'thin space
        strDoc = Replace(strDoc, "&thnsp;", "&#8201;") 'Presumably a half-space
        strDoc = Replace(strDoc, "&THORN;", "&#222;") 'Latin capital letter THORN
        strDoc = Replace(strDoc, "&thorn;", "&#254;") 'Latin small letter thorn
        strDoc = Replace(strDoc, "&tilde;", "&#732;") 'small tilde
        strDoc = Replace(strDoc, "&times;", "&#215;") 'multiplication sign
        strDoc = Replace(strDoc, "&times;", "x") ' *
        strDoc = Replace(strDoc, "&trade;", "&#8482;") 'trade mark sign
        strDoc = Replace(strDoc, "&Uacute;", "&#218;") 'Latin capital letter U with acute
        strDoc = Replace(strDoc, "&uacute;", "&#250;") 'Latin small letter u with acute
        strDoc = Replace(strDoc, "&uarr;", "&#8593;") 'upwards arrow
        strDoc = Replace(strDoc, "&uArr;", "&#8657;") 'upwards double arrow
        strDoc = Replace(strDoc, "&Ucirc;", "&#219;") 'Latin capital letter U with circumflex
        strDoc = Replace(strDoc, "&ucirc;", "&#251;") 'Latin small letter u with circumflex
        strDoc = Replace(strDoc, "&Ugrave;", "&#217;") 'Latin capital letter U with grave
        strDoc = Replace(strDoc, "&ugrave;", "&#249;") 'Latin small letter u with grave
        strDoc = Replace(strDoc, "&uml;", "&#168;") 'diaeresis
        strDoc = Replace(strDoc, "&upsih;", "&#978;") 'Greek upsilon with hook symbol
        strDoc = Replace(strDoc, "&Upsilon;", "&#933;") 'Greek capital letter upsilon
        strDoc = Replace(strDoc, "&upsilon;", "&#965;") 'Greek small letter upsilon
        strDoc = Replace(strDoc, "&utri;", "(triangle)") 'Open and closed triangles *
        strDoc = Replace(strDoc, "&utrif;", "(triangle)") ' *
        strDoc = Replace(strDoc, "&Uuml;", "&#220;") 'Latin capital letter U with diaeresis
        strDoc = Replace(strDoc, "&uuml;", "&#252;") 'Latin small letter u with diaeresis
        strDoc = Replace(strDoc, "&verbar;", "|") ' *
        strDoc = Replace(strDoc, "&weierp;", "&#8472;") 'script capital P = power set
        strDoc = Replace(strDoc, "&Xi;", "&#926;") 'Greek capital letter xi
        strDoc = Replace(strDoc, "&xi;", "&#958;") 'Greek small letter xi
        strDoc = Replace(strDoc, "&Yacute;", "&#221;") 'Latin capital letter Y with acute
        strDoc = Replace(strDoc, "&yacute;", "&#253;") 'Latin small letter y with acute
        strDoc = Replace(strDoc, "&yen;", "&#165;") 'yen sign
        strDoc = Replace(strDoc, "&yuml;", "&#255;") 'Latin small letter y with diaeresis
        strDoc = Replace(strDoc, "&Yuml;", "&#376;") 'Latin capital letter Y with diaeresis
        strDoc = Replace(strDoc, "&Zeta;", "&#918;") 'Greek capital letter zeta
        strDoc = Replace(strDoc, "&zeta;", "&#950;") 'Greek small letter zeta
        strDoc = Replace(strDoc, "&zwj;", "&#8205;") 'zero width joiner
        strDoc = Replace(strDoc, "&zwnj;", "&#8204;") 'zero width non-joiner

        'There are several other types of FP's in the DTD
        'FP-1, etc.
        strDoc = Replace(strDoc, "<F>", "") 'Fraction
        strDoc = Replace(strDoc, "</F>", "")
        strDoc = Replace(strDoc, "<P1>", "<P>") 'Indented paragraph 1
        strDoc = Replace(strDoc, "</P1>", "</P>")
        strDoc = Replace(strDoc, "<P2>", "<P>") 'Indented paragraph 2
        strDoc = Replace(strDoc, "</P2>", "</P>")
        strDoc = Replace(strDoc, "<FP>", "<P>") 'Flush paragraph
        strDoc = Replace(strDoc, "</FP>", "</P>")
        strDoc = Replace(strDoc, "<FRP>", "<P>") 'Flush right-paragraph
        strDoc = Replace(strDoc, "</FRP>", "</P>")
        strDoc = Replace(strDoc, "<FNP>", "") 'Force new page
        strDoc = Replace(strDoc, "</FNP>", "")
        strDoc = Replace(strDoc, "<FR>", "") 'Fraction
        strDoc = Replace(strDoc, "</FR>", "")
        strDoc = Replace(strDoc, "<SU>", "") 'Superscript
        strDoc = Replace(strDoc, "</SU>", "")
        strDoc = Replace(strDoc, "<SB>", "") 'Subscript
        strDoc = Replace(strDoc, "</SB>", "")
        strDoc = Replace(strDoc, "<STARS>", "") 'In 21CFR101.9 (no closing tag)
        strDoc = Replace(strDoc, "</STARS>", "")

        'Following are replaced after </EXTRACT>, because extracts use them
        strDoc = Replace(strDoc, "<FP-DASH>", "")
        strDoc = Replace(strDoc, "</FP-DASH>", "")
        strDoc = Replace(strDoc, "<HED>", "") 'Per DTD, usually the first head
        strDoc = Replace(strDoc, "</HED>", "") 'But not closed, so disregarded
        strDoc = Replace(strDoc, " & ", " and ")

        'Unclosed tags (closing tags replaced, if added later by GPO, but </Q>not seen)
        strDoc = Replace(strDoc, "<FTREF>", "")
        strDoc = Replace(strDoc, "</FTREF>", "")
        strDoc = Replace(strDoc, "<Q P=""01"">", "")
        strDoc = Replace(strDoc, "<Q P=""02"">", "")
        strDoc = Replace(strDoc, "<Q P=""03"">", "")
        strDoc = Replace(strDoc, "<Q P=""04"">", "")

        If InStr(strDoc, "<E") > 0 Then
            'Without a DTD, can't determine how many <E T="##">s there are,
            'so process all possible values; largest so far is 8401
            For intCtr = 1 To 9
                strTemp = "<E T=" & Chr(34) & "0" & CStr(intCtr) & Chr(34) & ">"
                strDoc = Replace(strDoc, strTemp, "")
            Next intCtr
            For intCtr = 10 To 99
                strTemp = "<E T=" & Chr(34) & CStr(intCtr) & Chr(34) & ">"
                strDoc = Replace(strDoc, strTemp, "")
            Next intCtr
        End If

        If InStr(strDoc, "<E") > 0 Then
            'Special-case tags
            strDoc = Replace(strDoc, "<E T=""8401"">", "")
            strDoc = Replace(strDoc, "<E T=""8051"">", "")
            strDoc = Replace(strDoc, "<E T=""8052"">", "")
            strDoc = Replace(strDoc, "<E T=""8073"">", "")
            strDoc = Replace(strDoc, "<E T=""0362"">", "")
            strDoc = Replace(strDoc, "<E T=""7481"">", "")
            strDoc = Replace(strDoc, "<E T=""7482"">", "")
            strDoc = Replace(strDoc, "<E T=""0182"">", "")
            strDoc = Replace(strDoc, "<E T=""7462"">", "")
            strDoc = Replace(strDoc, "<E T=""0084"">", "")
            strDoc = Replace(strDoc, "<E T=""0071"">", "")
        End If

        '</E> tags appear occasionally
        strDoc = Replace(strDoc, "</E>", "")

        'Accent (?) entity
        If InStr(strDoc, "<AC") > 0 Then
            '1 and 4 detected in Title 47
            For intCtr = 1 To 9
                strTemp = "<AC T=" & Chr(34) & CStr(intCtr) & Chr(34) & ">"
                strDoc = Replace(strDoc, strTemp, "")
            Next intCtr
        End If

        'Remove linefeeds and resulting doublespaces
        'Stray CRs and LFs occur in eCFR text
        strDoc = Replace(strDoc, vbCrLf, " ")
        strDoc = Replace(strDoc, Chr(10), " ")
        strDoc = Replace(strDoc, Chr(13), " ")
        strDoc = Replace(strDoc, "  ", " ")


        'Temporary for testing: Save the document in a text file
        If InStr(strDoc, "<E ") > 0 Then
            gstrFile = VB6.GetPath & "\Docerror.txt"
            'UPGRADE_WARNING: Dir has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
            If Len(Dir(gstrFile)) > 0 Then
                Kill(gstrFile)
            End If
            FileOpen(1, gstrFile, OpenMode.Binary)
            'UPGRADE_WARNING: Put was upgraded to FilePut and has a new behavior. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1041"'
            FilePut(1, "Unhandled <E tag: " & strTemp & vbCrLf & strDoc)
            FileClose(1)
            'UPGRADE_WARNING: Couldn't resolve default property of object varShell. Click for more: 'ms-help://MS.VSCC/commoner/redir/redirect.htm?keyword="vbup1037"'
            varShell = Shell("Notepad.exe " & gstrFile, AppWinStyle.NormalFocus)
            Stop
        End If


        strXML = gstrCFRSect & vbCrLf & "   <Header>" & vbCrLf
        If blnIsAppdx Then
            strXML = strXML & Space(6) & "<Volume>Appendix to Title " & strTitleID & " Part " & strPartID & " from the Electronic CFR (eCFR Beta)</Volume>" & vbCrLf
        Else
            strXML = strXML & Space(6) & "<Volume>Section " & strTitleID & "CFR" & strPartID & "." & strSectID & " from the Electronic CFR (eCFR Beta)</Volume>" & vbCrLf
        End If
        strXML = strXML & Space(6) & "<Revised>Current as of " & strRevDate & "</Revised>" & vbCrLf
        If blnIsAppdx Then
            'Temporary hack for Appendixes to Title 12, Part 27
            strSectID = Replace(strSectID, "=" & Chr(34), "")
            strTemp = Mid(strSectID, 4)
            If Len(strTemp) = 2 And Val(Right(strTemp, 1)) = 0 Then
                strXML = strXML & Space(6) & "<Citation>" & strTitleID & "CFR" & strPartID & " Subpart " & Left(strTemp, 1) & " Appendix " & Right(strTemp, 1) & "</Citation>" & vbCrLf
            ElseIf Len(strTemp) = 1 Or Val(Right(strTemp, 1)) > 0 Then
                strXML = strXML & Space(6) & "<Citation>" & strTitleID & "CFR" & strPartID & " Appendix " & strTemp & "</Citation>" & vbCrLf
            Else
                strXML = strXML & Space(6) & "<Citation>" & strTitleID & "CFR" & strPartID & " Appendix</Citation>" & vbCrLf
            End If
        Else
            strXML = strXML & Space(6) & "<Citation>" & strTitleID & "CFR" & strPartID & "." & strSectID & "</Citation>" & vbCrLf
        End If

        'Get the <CFR> elements (subtitle, chapter, and subchapter are present only when applicable)
        strText = ""
        For intCtr = 1 To 7
            Select Case intCtr
                Case 1
                    strFind = "<BTI>"
                    strTag = "Title"
                Case 2
                    strFind = "<BSUBTI>"
                    strTag = "Subtitle"
                Case 3
                    strFind = "<BCH>"
                    strTag = "Chapter"
                Case 4
                    strFind = "<BSUBCH>"
                    strTag = "Subchapter"
                Case 5
                    strFind = "<BPT>"
                    strTag = "Part"
                Case 6
                    strFind = "<BSUBPT>"
                    strTag = "Subpart"
                Case 7
                    If blnIsAppdx Then
                        strFind = "<BAPP>"
                    Else
                        strFind = "<BSEC>"
                    End If
                    strTag = "Section"
            End Select
            If InStr(strDoc, strFind) > 0 Then
                strTemp = Mid(strDoc, InStr(strDoc, strFind) + Len(strFind))
                strEnd = "</" & Mid(strFind, 2)
                If InStr(strTemp, strEnd) > 0 Then
                    strTemp = Left(strTemp, InStr(strTemp, strEnd) - 1)
                    If intCtr = 1 Then
                        'Fix the title line (remove CFR and add TITLE)
                        strText = "TITLE " & Left(strTemp, InStr(strTemp, " ") - 1)
                        'Change 9/04/01 to eliminate subject
                        If InStr(strTemp, "-") Then
                            strText = strText & " - " & UCase(Mid(strTemp, InStr(strTemp, "-") + 1))
                        End If
                    Else
                        strText = strTemp
                    End If
                    If intCtr = 3 Then
                        'Required to retain capitalized Roman numerals
                        strText = Replace(strText, "CHAPTER", "Chapter")
                    End If
                    If intCtr = 5 Then
                        strText = Replace(strText, "PART", "Part")
                    End If
                    If intCtr < 7 Then
                        strFind = Left(strFind, Len(strFind) - 1)
                        strFind = strFind & "SB>"
                    Else
                        'Sometimes "part" isn't capitalized
                        strText = Replace(strText, "part", "Part")
                        'Retro-fix for subpart
                        strText = Replace(strText, "SubPart", "Subpart")
                        strText = Replace(strText, "--", " - ")
                        strFind = "<SUBJECT>"
                    End If
                    If InStr(strDoc, strFind) > 0 Then
                        strTemp = Mid(strDoc, InStr(strDoc, strFind) + Len(strFind))
                        strEnd = "</" & Mid(strFind, 2)
                        If InStr(strTemp, strEnd) > 0 Then
                            'Some parts have <SU>...</SU> tags and double-spaces
                            strTemp = Replace(strTemp, "<SU>", "")
                            strTemp = Replace(strTemp, "</SU>", "")
                            strTemp = Replace(strTemp, "  ", " ")
                            strTemp = Left(strTemp, InStr(strTemp, strEnd) - 1)
                            If intCtr = 1 Then 'Title
                                If blnIsAppdx Then
                                    'Stop
                                End If
                                'Hack for eCFR format change on 9/04/01
                                If InStr(strTemp, " - ") = 0 Then
                                    strTemp = UCase(strTemp)
                                Else
                                    strTemp = ""
                                End If
                            ElseIf intCtr = 3 Or intCtr = 5 Then
                                strTemp = ToILC(strTemp)
                            End If
                            If Len(strTemp) > 0 Then
                                strText = strText & " - " & Trim(strTemp)
                            End If
                        Else
                            'error
                        End If
                    Else
                        'error
                    End If
                Else
                    'error
                End If
            Else
                strText = ""
            End If
            'Provide empty tags for missing elements
            strXML = strXML & Space(6) & "<" & strTag & ">" & Trim(strText) & "</" & strTag & ">" & vbCrLf
        Next intCtr
        strXML = strXML & "   </Header>" & vbCrLf
        'Remove the processed components

        If InStr(strDoc, strEnd) > 0 Then
            strDoc = Trim(Mid(strDoc, InStr(strDoc, strEnd) + Len(strEnd)))
        Else
            'error
        End If

        If InStr(strDoc, "<EXTRACT>") > 0 Or InStr(strDoc, "<EXHIBIT>") Then
            'EXTRACTs and EXHIBITs must be processed first, because they often are structured
            'With multi-level headings
            For intType = 1 To 2
                If intType = 1 Then
                    strType = "Extract"
                Else
                    strType = "Exhibit"
                End If
                'Reset for new element
                strExt = ""
                Do While InStr(strDoc, "<" & UCase(strType) & ">") > 0 And InStr(strDoc, "</" & UCase(strType) & ">") > 0
                    'Extracts have headings and paragraphs, but not a consistent structure
                    intLevel = 1
                    intLastLevel = 0
                    blnHasHead = False
                    '"Exhibit" and "Extract" are the same length (7 chars)
                    strTemp = Trim(Mid(strDoc, InStr(strDoc, "<" & UCase(strType) & ">") + 9))
                    If InStr(strDoc, "</" & UCase(strType) & ">") > 0 Then
                        strExt = strExt & "   <" & strType & ">" & vbCrLf
                        strTemp = Trim(Left(strTemp, InStr(strTemp, "</" & UCase(strType) & ">") - 1))
                        If InStr(strTemp, "<HD") = 0 Then
                            'There are no headings, everything's at the same level
                            intLastLevel = 1
                            intSp = 3
                        End If
                        '<P>...</P> is missing from <HD1>...<HD?>
                        strTemp = Replace(strTemp, "<HD1>", "<P><HD1>")
                        strTemp = Replace(strTemp, "</HD1>", "</HD1></P>")
                        strTemp = Replace(strTemp, "<HD2>", "<P><HD2>")
                        strTemp = Replace(strTemp, "</HD2>", "</HD2></P>")
                        strTemp = Replace(strTemp, "<HD3>", "<P><HD3>")
                        strTemp = Replace(strTemp, "</HD3>", "</HD3></P>")
                        strTemp = Replace(strTemp, "<HD4>", "<P><HD4>")
                        strTemp = Replace(strTemp, "</HD4>", "</HD4></P>")

                        strTemp = Replace(strTemp, "<FP-1>", "<P>")
                        strTemp = Replace(strTemp, "</FP-1>", "</P>")
                        strTemp = Replace(strTemp, "<FP-2>", "<P>")
                        strTemp = Replace(strTemp, "</FP-2>", "</P>")
                        strTemp = Replace(strTemp, "<FP-3>", "<P>")
                        strTemp = Replace(strTemp, "</FP-3>", "</P>")

                        strTemp = Replace(strTemp, "<SU>", "")
                        strTemp = Replace(strTemp, "</SU>", ". ")

                        blnFirstHead = True
                        If Left(strTemp, 1) <> "<" Then
                            'HED or something else was deleted in a
                            If InStr(strTemp, "<P") > 0 Or InStr(strTemp, "<H") > 0 Then
                                If InStr(strTemp, "<H") = 0 Or (InStr(strTemp, "<P") < InStr(strTemp, "<H")) Then
                                    'Check for a </P> preceding the first <P>
                                    strText = Left(strTemp, InStr(strTemp, "<P") - 1)
                                    strTag = "P"
                                Else
                                    strText = Left(strTemp, InStr(strTemp, "<H") - 1)
                                    strTag = "H"
                                End If
                                If InStr(strText, "</") > 0 Then
                                    'what is it
                                    Stop
                                Else
                                    strTemp = Mid(strTemp, InStr(strTemp, "<" & strTag))
                                    strTemp = "<P>" & Trim(strText) & "</P>" & strTemp
                                End If
                            End If
                        End If
                        If InStr(strTemp, "<P>") > 0 Then
                            Do While InStr(strTemp, "<P>") > 0 And InStr(strTemp, "</P>") > 0
                                strText = Mid(strTemp, InStr(strTemp, "<P>") + 3)
                                If InStr(strText, "</P>") > 0 Then
                                    strText = Trim(Left(strText, InStr(strText, "</P>") - 1))
                                    If Left(strText, 3) = "<HD" Then
                                        'It's a heading
                                        If Right(strExt, 7) = "</HD" & CStr(intLastLevel) & ">" & vbCrLf Then
                                            'There's no text
                                            strExt = strExt & Space(intSp) & "<Para" & CStr(intLastLevel) & " />" & vbCrLf
                                        End If
                                        If blnFirstHead Then
                                            intLevel = Val(Mid(strText, 4, 1))
                                            If intLevel <> 1 Then
                                                'Change it to 1 and keep it
                                                intLevel = 1
                                            Else
                                                blnFirstHead = False
                                            End If
                                        Else
                                            intLevel = Val(Mid(strText, 4, 1))
                                        End If
                                        strText = Mid(strText, 6)
                                        strText = Left(strText, InStr(strText, "</HD") - 1)
                                        intSp = (3 * intLevel) + 3
                                        If intLevel <= intLastLevel And blnHasHead Then
                                            strExt = strExt & Space((3 * intLastLevel) + 3) & "</Head" & CStr(intLastLevel) & ">" & vbCrLf
                                            If intLevel < intLastLevel Then
                                                strExt = strExt & Space(intSp) & "</Head" & CStr(intLevel) & ">" & vbCrLf
                                            End If
                                            blnHasHead = False
                                        End If
                                        strExt = strExt & Space(intSp) & "<Head" & CStr(intLevel) & ">" & vbCrLf
                                        strExt = strExt & Space(intSp + 3) & strText & vbCrLf
                                        blnHasHead = True
                                    Else
                                        'It's paragraphs
                                        strExt = strExt & Space(intSp + 3) & "<Para" & CStr(intLevel) & ">" & vbCrLf
                                        strExt = strExt & Space(intSp + 6) & Replace(strText, vbCrLf, " ") & vbCrLf
                                        If intLevel <= intLastLevel Then
                                            strExt = strExt & Space(intSp + 3) & "</Para" & CStr(intLastLevel) & ">" & vbCrLf
                                            If intLevel < intLastLevel Then
                                                'Paragraphs should always be at the same level
                                                strExt = strExt & Space(intSp) & "</Para" & CStr(intLevel) & ">" & vbCrLf
                                            End If
                                        Else
                                            If intLastLevel = 0 Then
                                                'Hack for exhibits
                                                strExt = strExt & Space(9) & "</Para1>" & vbCrLf
                                            End If
                                        End If
                                    End If
                                Else
                                    'Just a chunk of text
                                    strExt = strExt & str6 & "<Para1>" & vbCrLf
                                    strExt = strExt & str9 & Replace(strText, vbCrLf, " ") & vbCrLf
                                    strExt = strExt & str6 & "</Para1>" & vbCrLf
                                    intLevel = 1
                                End If
                                intLastLevel = intLevel
                                strTemp = Mid(strTemp, InStr(strTemp, "</P>") + 4)
                                If InStr(strExt, "Head1") > 0 Then
                                    'Stop
                                End If
                            Loop
                        Else
                            'Also a chunk of text (occurs in exhibits
                            strExt = strExt & str6 & "<Para1>" & vbCrLf
                            'The below doesn't occur often but, big problems when it does
                            strText = Replace(strText, "<", "[")
                            strText = Replace(strText, ">", "]")
                            strExt = strExt & str9 & Replace(strText, vbCrLf, " ") & vbCrLf
                            strExt = strExt & str6 & "</Para1>" & vbCrLf
                            intLevel = 1
                        End If

                        If blnHasHead Then
                            'Add the closing head tags
                            For intCtr = intLastLevel To 1 Step -1
                                If InStr(strExt, "<Head" & CStr(intCtr) & ">") > 0 Then
                                    intSp = (3 * intCtr) + 3
                                    strExt = strExt & Space(intSp) & "</Head" & CStr(intCtr) & ">" & vbCrLf
                                End If
                            Next intCtr
                        End If
                        strExt = strExt & "   </" & strType & ">" & vbCrLf
                        strTemp = Left(strDoc, InStr(strDoc, "<" & UCase(strType) & ">") - 1)
                        strDoc = strTemp & Mid(strDoc, InStr(strDoc, "</" & UCase(strType) & ">") + 10)
                    Else
                        'error
                    End If
                Loop
            Next intType
        End If

        'Replace all <FP-?>s and <HD-?>s after processing extracts
        For intCtr = 1 To 6
            strDoc = Replace(strDoc, "<FP-" & CStr(intCtr) & ">", "<P>")
            strDoc = Replace(strDoc, "</FP-" & CStr(intCtr) & ">", "</P>")
        Next intCtr
        For intCtr = 1 To 6
            strDoc = Replace(strDoc, "<HD" & CStr(intCtr) & ">", "<P>")
            strDoc = Replace(strDoc, "</HD" & CStr(intCtr) & ">", "</P>")
        Next intCtr

        For intCtr = 1 To 10
            'Generic process for converting various SGML elements to endnotes
            Select Case intCtr
                Case 1
                    strTag = "AUTH"
                    strPref = ""
                Case 2
                    strTag = "NOTE"
                    strPref = ""
                Case 3
                    strTag = "APPRO"
                    strPref = "Approval: "
                Case 4
                    strTag = "EXAMPLE"
                    strPref = ""
                Case 5
                    strTag = "SECAUTH"
                    strPref = "Section Authorization: "
                Case 6
                    'Ears appear to be references to appendices
                    strTag = "EAR"
                    strPref = "Reference: "
                Case 7
                    strTag = "EFFDNOT"
                    strPref = ""
                Case 8
                    strTag = "FTNT"
                    strPref = "Footnote: "
                Case 9
                    strTag = "EDNOTE"
                    strPref = ""
                Case 10
                    strTag = "EXT-XREF"
                    strPref = "External Cross Reference: "
            End Select
            If InStr(strDoc, "<" & strTag) > 0 Then
                'Some sections might have multiple notes
                Do While InStr(strDoc, "<" & strTag) > 0
                    If InStr(strDoc, "</" & strTag & ">") > 0 Then
                        'Temporary for test
                        strText = Mid(strDoc, InStr(strDoc, "<" & strTag) + Len(strTag) + 2)
                        strText = Left(strText, InStr(strText, "</" & strTag & ">") - 1)
                        If InStr(strText, ">") > 0 Then
                            'Occurs in SECAUTH, for example
                            strText = Mid(strText, InStr(strText, ">") + 1)
                        End If
                        If InStr(strText, "<SU>") > 0 Then
                            strTemp = Mid(strText, InStr(strText, "<SU>") + 4)
                            strTemp = Trim(Left(strTemp, InStr(strTemp, "</SU>") - 1))
                            strText = Mid(strText, InStr(strText, "</SU>") + 5)
                            If Len(strPref) > 0 Then
                                'Subject is parenthetical
                                strPref = Left(strPref, InStr(strPref, ":") - 1)
                                strPref = strPref & " (" & strTemp & "): "
                            Else
                                'Subject becomes a prefix
                                strPref = strTemp & ": "
                            End If
                        End If
                        If Len(strPref) > 0 Then
                            'Remove parenthesis
                            strText = Replace(strText, "(", "")
                            strText = Replace(strText, ")", "")
                        End If
                        strText = Replace(strText, "<Para1>", "")
                        strText = Replace(strText, "</Para1>", " ")
                        strText = Replace(strText, "<P>", "")
                        strText = Replace(strText, "</P>", " ")
                        strText = Replace(strText, "  ", " ")
                        strEndNote = strEndNote & Space(6) & "<Para1>" & vbCrLf
                        strEndNote = strEndNote & Space(9) & strPref & Replace(strText, vbCrLf, " ") & vbCrLf
                        strEndNote = strEndNote & Space(6) & "</Para1>" & vbCrLf
                        strTemp = Mid(strDoc, InStr(strDoc, "</" & strTag & ">") + Len(strTag) + 3)
                        strDoc = Left(strDoc, InStr(strDoc, "<" & strTag) - 1)
                        strDoc = strDoc & Trim(strTemp)
                    Else
                        'Error
                        Exit Do
                    End If
                Loop
            End If
        Next intCtr

        Do While InStr(strDoc, "<CITA ")
            'Process the FedReg citation(s) - may be more than one
            strTemp = Mid(strDoc, InStr(strDoc, "<CITA "))
            strTemp = Mid(strTemp, InStr(strTemp, ">") + 1)
            If InStr(strDoc, "</CITA>") > 0 Then
                strTemp = Left(strTemp, InStr(strTemp, "</CITA>") - 1)
                If InStr(strTemp, "[") > 0 Then
                    strFedReg = Mid(strTemp, InStr(strTemp, "["))
                    If InStr(strFedReg, "]") > 0 Then
                        strFedReg = Left(strFedReg, InStr(strFedReg, "]"))
                    Else
                        'Occasionally the closing bracket is missing
                        strFedReg = strTemp & "]"
                    End If
                Else
                    'error
                End If
                strTemp = Left(strDoc, InStr(strDoc, "<CITA ") - 1)
                strDoc = strTemp & Mid(strDoc, InStr(strDoc, "</CITA>") + 7)
            Else
                'error
            End If
        Loop

        strDoc = Trim(strDoc)
        If Len(strDoc) > 0 Then
            'Instances of a repeated subject line have been encountered
            If Left(strDoc, 9) = "<SUBJECT>" Then
                If InStr(strDoc, "</SUBJECT>") > 0 Then
                    'Remove the duplicate subject entry
                    strDoc = Trim(Mid(strDoc, InStr(strDoc, "</SUBJECT>") + 10))
                End If
            End If
            If Left(strDoc, 3) <> "<P>" Then
                If Left(strDoc, 7) = "<Para1>" Then
                    'It starts with a HED or FP or the like (abnormal)
                    strDoc = Replace(strDoc, "<Para1>", "<P>")
                    strDoc = Replace(strDoc, "</Para1>", "</P>")
                Else
                    'what is it? sometimes it's multiple section numbers
                    'Stop
                End If
            End If
        End If

        'Most sections have at least one Para1 (some have more)
        'An empty <Para1>...</Para1> pair occurs when sections start with (a)
        strXML = strXML & "   <Body>" & vbCrLf & "      <Para1>" & vbCrLf

        'Process the body text (use of Split$ was investigated and abandoned)
        strText = ""
        strLastSubPara = ""
        blnIsBody = True
        intLastLevel = 0
        Do While InStr(strDoc, "<P>") > 0
            'Process each paragraph and assign its level
            intNewLevel = 0
            If Left(Trim(strDoc), 4) = "<P>" And InStr(strDoc, "</P>") > 0 Then
                strText = Left(strDoc, InStr(strDoc, "</P>") - 1)
                If InStr(strText, ". (") Then
                    'This condition handles '.....text. (1)' and the like
                    'Stop
                    strText = Replace(strText, ". (", ". </P><P>(")
                    strDoc = strText & Mid(strDoc, InStr(strDoc, "</P>"))
                End If

                'A special case (see
                If InStr(strText, "-(1)") Then
                    'This condition handles '.....-(1)'
                    'Stop
                    strText = Replace(strText, "-(1)", " </P><P>(1)")
                    strDoc = strText & Mid(strDoc, InStr(strDoc, "</P>"))
                End If

                If InStr(strText, ")(") > 0 Then
                    'Stop
                    If InStr(strText, ")(") < 8 Then
                        'This condition handles '(c)(1)(i)' or '(1)(i)'
                        'at the start of a paragraph
                        System.Diagnostics.Debug.WriteLine(strText)
                        'Stop
                        strText = Replace(strText, ")(", ")</P><P>(")
                        strDoc = strText & Mid(strDoc, InStr(strDoc, "</P>"))
                    End If
                End If
            End If

            strText = Mid(strDoc, InStr(strDoc, "<P>") + 3)
            If InStr(strText, "</P>") > 0 Then
                strText = Left(strText, InStr(strText, "</P>") - 1)
                If Left(strText, 1) = "(" Then
                    'Handle illegitimate situations, such as (c)(1)(i)
                    strTemp = Mid(strText, 2, 1)
                    If Val(strTemp) > 0 Or (intLastLevel = 2 And InStr(strText, "(i)") > 0) Then
                        'Numbered paragraph or a Para4 following a Para2
                        intLevel = 3
                        If intLastLevel < 3 Then
                            'In some cases, (1) doesn't have a <P> marker (bug?)
                            'In others, Para3 follows the body text (no Para2's)
                            If Val(strTemp) <> 1 Then
                                If InStr(strLastText, "(1)") > 0 Then
                                    'The </P><P> was missing, go back and fix it
                                    strXML = Trim(Left(strXML, InStrRev(strXML, "(1)") - 1)) & vbCrLf
                                    strXML = strXML & Space(12) & "<Para3>" & vbCrLf
                                    strLastText = Trim(Mid(strLastText, InStr(strLastText, "(1)")))
                                    strXML = strXML & Space(15) & strLastText & vbCrLf
                                    strXML = strXML & Space(12) & "</Para3>" & vbCrLf
                                End If
                            End If
                        End If
                    ElseIf LCase(strTemp) = strTemp Then
                        'Lower-case letter
                        If InStr("ivx", strTemp) Then
                            intLevel = 4
                            If intLastLevel = 2 Then
                                'Illegal jump from level 2 to level 4
                                strXML = strXML & Space(12) & "<Para3>" & vbCrLf
                            End If

                            'If intLastLevel = 3 Then
                            If intLastLevel = 10 Then 'Temporary for test
                                'In some cases, (i) doesn't have a <P> marker (bug?)
                                'Same issue as numbered paragraphs
                                If Left(strText, 3) <> "(i)" Then
                                    If InStr(strLastText, "(i)") > 0 Then
                                        'The </P><P> was missing, go back and fix it
                                        strXML = Trim(Left(strXML, InStrRev(strXML, "(i)") - 1)) & vbCrLf
                                        strXML = strXML & Space(15) & "<Para4>" & vbCrLf
                                        strLastText = Trim(Mid(strLastText, InStr(strLastText, "(i)")))
                                        strXML = strXML & Space(18) & strLastText & vbCrLf
                                        strXML = strXML & Space(15) & "</Para4>" & vbCrLf
                                    End If
                                End If
                            End If
                        Else
                            intLevel = 2
                            blnIsBody = False
                        End If
                    ElseIf UCase(strTemp) = strTemp Then
                        'Upper-case letter
                        intLevel = 5
                        If intLastLevel = 3 Then
                            'Illegal jump from level 3 to level 5 (see 21CFR101.9)
                            'Needs an empty <Para4> (responsible for many early parse errors)
                            strXML = strXML & Space(15) & "<Para4>" & vbCrLf
                        End If
                    End If
                Else
                    If blnIsBody Then
                        'There can be only one body paragraph (the first)
                        intLevel = 1
                        blnIsBody = False
                    Else
                        'It's a <P>...</P> at a lower level, so is bogus
                        'Add it to the preceding text
                        strEnd = ""
                        If InStr(strXML, vbCrLf & Space(intSp) & "</Para") > 0 Then
                            strEnd = Mid(strXML, InStrRev(strXML, vbCrLf & Space(intSp) & "</Para"))
                            strXML = Left(strXML, InStrRev(strXML, vbCrLf & Space(intSp) & "</Para") - 1)
                        End If
                        strXML = strXML & " " & Replace(strText, vbCrLf, " ") & strEnd & vbCrLf
                        strLastText = strLastText & " " & strText
                        strDoc = Mid(strDoc, InStr(strDoc, "</P>") + 4)
                        blnBogusPara = True
                    End If
                End If

                If blnBogusPara Then
                    'Reset the flag
                    blnBogusPara = False
                Else
                    'Add the element
                    intSp = 3 * (intLevel + 1)
                    If intLevel > 1 Then
                        If intLevel <= intLastLevel Then
                            If intLastLevel = 4 Then
                                'Stop
                            End If

                            strXML = strXML & Space(3 * (intLastLevel + 1)) & "</Para" & CStr(intLastLevel) & ">" & vbCrLf
                            If intLevel < intLastLevel Then
                                For intCtr = intLastLevel - 1 To intLevel Step -1
                                    If InStr(strXML, "<Para" & intCtr) > 0 Then
                                        'Para2s are sometimes missing
                                        strXML = strXML & Space(3 * (intCtr + 1)) & "</Para" & CStr(intCtr) & ">" & vbCrLf
                                    End If
                                Next intCtr
                            End If
                        End If
                        'Add the subparagraphs
                        strXML = strXML & Space(intSp) & "<Para" & CStr(intLevel) & ">" & vbCrLf
                        strXML = strXML & Space(intSp + 3) & Replace(strText, vbCrLf, " ") & vbCrLf
                    Else
                        'It's body text
                        strXML = strXML & Space(intSp + 3) & Replace(strText, vbCrLf, " ") & vbCrLf
                    End If
                    strDoc = Mid(strDoc, InStr(strDoc, "</P>") + 4)
                    intLastLevel = intLevel
                    strLastSubPara = strTemp
                    strLastText = strText
                End If
            Else
                ECFRFormatXML = "ERROR: Malformed eCFR document."
                Call SaveErrors(strTitleID, strPartID, strSectID, ECFRFormatXML)
                Exit Function
            End If
        Loop

        'Close the open tags
        If intLastLevel > 1 Then
            For intCtr = intLastLevel To 2 Step -1
                If InStr(strXML, "<Para" & intCtr) > 0 Then
                    'Para2s are sometimes missing
                    strXML = strXML & Space(3 * (intCtr + 1)) & "</Para" & CStr(intCtr) & ">" & vbCrLf
                End If
            Next intCtr
        End If

        If Right(Trim(strXML), 2) = vbCrLf Then
            strXML = strXML & Space(6) & "</Para1>" & vbCrLf
        Else
            strXML = strXML & vbCrLf & Space(6) & "</Para1>" & vbCrLf
        End If

        If InStr(strDoc, "<Para1>") > 0 And InStr(strDoc, "</Para1>") > 0 Then
            'Trailing <FP>...</FP> goes at end of body
            strTemp = Mid(strDoc, InStr(strDoc, "<Para1>") + 7)
            strTemp = Left(strTemp, InStr(strTemp, "</Para1>") - 1)
            strTemp = Space(6) & "<Para1>" & vbCrLf & Space(9) & strTemp & vbCrLf & Space(6) & "</Para1>" & vbCrLf
            strXML = strXML & strTemp
            strDoc = Mid(strDoc, InStr(strDoc, "</Para1>") + 8)
        End If

        If Len(strDoc) > 50 Then
            strEndNote = strEndNote & Space(6) & "<Para1>" & vbCrLf
            strEndNote = strEndNote & Space(9) & "Some of the content is missing from this section due to inability to format as XML." & vbCrLf
            If InStr(strEndNote, "<URL>") = 0 Then
                strEndNote = strEndNote & Space(9) & "<URL>" & vbCrLf & Space(12) & strURL & vbCrLf & Space(9) & "</URL>" & vbCrLf
            End If
            strEndNote = strEndNote & Space(6) & "</Para1>" & vbCrLf
        End If
        strXML = strXML & "   </Body>" & vbCrLf

        'Add the <EXTRACT> and <EndNote> elements
        If Len(strExt) > 0 Then
            strXML = strXML & strExt
        End If
        If Len(strEndNote) > 0 Then
            strXML = strXML & "   <EndNote>" & vbCrLf & strEndNote
            strXML = strXML & "   </EndNote>" & vbCrLf
            strEndNote = ""
        End If
        If Len(strFedReg) > 0 Then
            strXML = strXML & "   <FedReg>" & vbCrLf & Space(6) & strFedReg & vbCrLf
            strXML = strXML & "   </FedReg>" & vbCrLf
            strFedReg = ""
        End If
        'Closing tag
        strXML = strXML & "</CFRSect>"
        ECFRFormatXML = strXML
    End Function

    Private Sub Class_Terminate_Renamed()
        'Clean up on error
        With cnnCFR
            If .State = ADODB.ObjectStateEnum.adStateOpen Then
                .Close()
            End If
        End With
    End Sub
    Protected Overrides Sub Finalize()
        Class_Terminate_Renamed()
        MyBase.Finalize()
    End Sub
End Class