VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFRSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private cnnCFR As New ADODB.Connection
Private cmmCFR As New ADODB.Command

'DOCTYPE declaration won't parse and current documents don't conform to
'strict or transitional
'Private Const strXHTMLHeader As String = "<!DOCTYPE html " & vbCrLf & _
'"   PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'" & vbCrLf & _
'"   'DTD/xhtml1-strict.dtd' >" & vbCrLf & _
'"<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf

Private Const strXMLPrefix As String = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & vbCrLf
Private Const strXHTMLHeader As String = "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf
Private Const strCFRSearch As String = "<CFRSearch xmlns:CFRSections=""http://www.oakmont.org/CFR/Search"" >" & vbCrLf
Private Const strCSSSearch As String = "<link rel='stylesheet' href='CFRSearch.css' type='text/css' />" & vbCrLf

Public Function GetSearchResults(ByVal strConnect As String, _
                                 ByVal strSearch As String, _
                                 ByVal intMaxHits As Integer, _
                                 ByVal intMinLevel As Integer, _
                                 ByVal intMaxLevel As Integer, _
                                 ByVal strTitleID As String, _
                                 ByVal lngTOCItems As Long, _
                                 ByVal lngSectItems As Long, _
                                 ByVal strSearchType As String) As String
   
   Dim rstSearch As New ADODB.Recordset
   Dim rstTest As New ADODB.Recordset
   
   Dim colTitles As New Collection
   Dim colSubtitles As New Collection
   Dim colChapters As New Collection
   Dim colSubchapters As New Collection
   Dim colParts As New Collection
   Dim colSections As New Collection
   Dim colSearch As New Collection
   Dim colTemp As New Collection
   
   Dim strFields As String
   Dim strName As String
   Dim strTable As String
   Dim strSubtable As String
   Dim strSQL As String
   Dim strHits As String
   Dim strItem As String
   Dim strId As String
   Dim strAttrib As String
   Dim strTOC As String
   Dim strTest As String
   Dim strTemp As String
   Dim strXML As String
   Dim strLevel As String
   Dim strTableCols As String
   
   Dim intLevel As Integer
   Dim intField As Integer
   Dim intTitle As Integer
   Dim intSubtitle As Integer
   Dim intChapter As Integer
   Dim intSubchapter As Integer
   Dim intPart As Integer
   Dim intHits As Integer
   Dim intPos As Integer
   Dim intCtr As Integer
   Dim intLimit As Integer
   
   Dim sngTime As Single
   
   Dim blnIsMax As Boolean
   Dim blnHasBody As Boolean
   
   On Error GoTo SearchResultsErr
   
   If intMaxHits > 100 Then
      'Limit the maximum number of hits for this version
      intMaxHits = 100
   End If
   
   If Len(Trim$(strSearch)) < 4 Then
      'Handle an empty search string
      If strSearchType = "XHTML" Then
         GetSearchResults = TransformXMLSearch("ERROR: Search string must contain at least four characters.")
      Else
         GetSearchResults = "ERROR: Search string must contain at least four characters."
      End If
      GoTo SearchResultsExit
   End If
   
   intLimit = intMaxHits
   sngTime = Timer
   For intLevel = intMaxLevel To intMinLevel Step -1
      Select Case intLevel
         Case 0
            'Special case for TitleTOC (for completeness)
            strFields = " TOCText "
            strTable = "TitlesTOC"
         Case 1
            strFields = " TitleID, Title "
            strTable = "Titles"
            strSubtable = "Subtitles"
         Case 2
            strFields = " TitleID, Title "
            strTable = "Titles"
            strSubtable = "Chapters"
         Case 3
            strFields = " TitleID, SubtitleID, Subtitle "
            strTable = "Subtitles"
            strSubtable = "Chapters"
         Case 4
            strFields = " TitleID, SubtitleID, ChapterID, ChapterNum, Chapter "
            strTable = "Chapters"
            strSubtable = "Subchapters"
         Case 5
            strFields = " TitleID, SubtitleID, ChapterID, SubchapterID, Subchapter "
            strTable = "Subchapters"
            strSubtable = "Parts"
         Case 6
            strFields = " TitleID, SubtitleID, ChapterID, SubchapterID, PartID, Part "
            strTable = "Parts"
            strSubtable = "Sections"
         Case 7
            strFields = " TitleID, PartID, SectionID, Section "
            strTable = "Sections"
            strSubtable = ""
      End Select
      
      'Do the first level search in the TOCText field
      strSQL = "SELECT TOP " & CStr(intMaxHits) & strFields & _
         "FROM " & strTable & " WHERE CONTAINS(TOCText, '"
      If InStr(strSearch, Chr$(34)) > 0 Then
         If Right$(strSearch, 1) <> Chr$(34) Then
            strSearch = Replace$(strSearch, "'", "''") & Chr$(34)
         End If
         strSQL = strSQL & " " & Replace$(strSearch, "'", "''") & " ') "
      ElseIf InStr(strSearch, "*") > 0 Then
         strSQL = strSQL & Chr$(34) & " " & Replace$(strSearch, "'", "''") & Chr$(34) & " ') "
      Else
         strSQL = strSQL & Replace$(strSearch, "'", "''") & "') "
      End If
      If intLevel > 0 Then
         If Len(strTitleID) > 0 Then
            strSQL = strSQL & " AND TitleID = " & strTitleID & " "
         End If
         'Add the union for TOCChar (The TitlesTOC table doesn't have TOCChar)
         strSQL = strSQL & "UNION " & Replace$(strSQL, "TOCText", "TOCChar")
         If intLevel = 7 Then
            strSQL = Replace(strSQL, "TOC", "Sect")
         End If
         With rstSearch
            If .State = adStateOpen Then
               .Close
            End If
         End With
      End If
            
      With cnnCFR
         If .State = adStateClosed Then
            .CommandTimeout = 300
            .Open strConnect
            'Define a Command object
            Set cmmCFR.ActiveConnection = cnnCFR
         End If
      End With
      Set rstSearch = cnnCFR.Execute(strSQL, , adCmdText)
      
      With rstSearch
         If .EOF Then
            'No hits
         Else
            If intLevel > 0 Then
               Do Until .EOF
                  If intLevel > 1 Then
                     strAttrib = ""
                  End If
                  strId = ""
                  For intField = 0 To .Fields.Count - 1
                     strItem = CStr(.Fields(intField).Value)
                     If intField < .Fields.Count - 1 Then
                        'Create the attribute code (for TOCs)
                        strItem = CStr(.Fields(intField).Value)
                        strName = CStr(.Fields(intField).Name)
                        strId = strItem
                        Select Case strName
                           Case "TitleID"
                              If intLevel > 1 Then
                                 strAttrib = "ti" & strItem
                              End If
                           Case "SubtitleID"
                              If intLevel > 1 Then
                                 strAttrib = strAttrib & "st" & Replace$(strItem, "-", "_")
                              End If
                           Case "ChapterID"
                              strAttrib = strAttrib & "ch" & strItem & "sc_"
                           Case "ChapterNum"
                              strId = strItem
                           Case "SubchapterID"
                              strAttrib = Left(strAttrib, InStr(strAttrib, "sc") - 1) & "sc" & Replace$(strItem, "-", "_")
                           Case "PartID"
                              strAttrib = strAttrib & "pn" & strItem
                           Case "SectionID"
                              strAttrib = strAttrib & "sn" & strItem
                        End Select
                     End If
                  Next intField
                 
                  'Test the subtable for the item
                  If intLevel < 7 Then
                     strTemp = Left$(strSubtable, Len(strSubtable) - 1)
                     'These queries require indexes on the name (e.g., Section)
                     'An index speeds the query by a factor of 50 or more
                     If strSubtable = "Chapters" Then
                        strSQL = "SELECT ChapterID, ChapterNum FROM " & strSubtable & " WHERE " & strTemp & " = '" & Replace(strItem, "'", "''") & "'"
                     Else
                        strSQL = "SELECT " & strTemp & "ID FROM " & strSubtable & " WHERE " & strTemp & " = '" & Replace(strItem, "'", "''") & "'"
                     End If
                     With rstTest
                        If .State = adStateOpen Then
                           .Close
                        End If
                     End With
                     Set rstTest = cnnCFR.Execute(strSQL, , adCmdText)
                     With rstTest
                        If .EOF Then
                           'No find
                        Else
                           If strSubtable = "Chapters" Then
                              strId = CStr(.Fields(1).Value)
                           Else
                              strId = CStr(.Fields(0).Value)
                           End If
                           If Right(strAttrib, 3) = "sc_" Then
                              strAttrib = Replace$(strAttrib, "sc_", "sc") & CStr(.Fields(0).Value)
                           End If
                        End If
                     End With
                     strItem = strId & " - " & strItem
                  Else
                     'Add the part number from the attribute
                     strItem = Mid$(strAttrib, InStr(strAttrib, "sn") + 2) & " - " & strItem
                  End If
                  
                  'Don't include duplicates or reserved items
                  If InStr(strHits, strItem) = 0 And InStr(UCase$(strItem), "[RESERVED]") = 0 Then
                     Select Case strTable
                        Case "Subtitles"
                           colSubtitles.Add strAttrib & ";" & strItem
                           If colSubtitles.Count >= intMaxHits Then
                              blnIsMax = True
                           End If
                           'intMaxHits = intMaxHits - 1
                        Case "Chapters"
                           colChapters.Add strAttrib & ";" & strItem
                           If colChapters.Count >= intMaxHits Then
                              blnIsMax = True
                           End If
                           'intMaxHits = intMaxHits - 1
                        Case "Subchapters"
                           colSubchapters.Add strAttrib & ";" & strItem
                           If colSubchapters.Count >= intMaxHits Then
                              blnIsMax = True
                           End If
                           'intMaxHits = intMaxHits - 1
                        Case "Parts"
                           colParts.Add strAttrib & ";" & strItem
                           If colParts.Count >= intMaxHits Then
                              blnIsMax = True
                           End If
                           'intMaxHits = intMaxHits - 1
                        Case "Sections"
                           colSections.Add strAttrib & ";" & strItem
                           If colSections.Count >= intMaxHits Then
                              blnIsMax = True
                           End If
                           'intMaxHits = intMaxHits - 1
                     End Select
                     strHits = strHits & strAttrib & ";" & strItem & vbCrLf
                     intHits = intHits + 1
                     If blnIsMax Then
                        Exit Do
                     End If
                  Else
                     'Stop
                  End If
                  .MoveNext
               Loop
               If blnIsMax Then
                  Exit For
               End If
            Else
               'Special Case: Perform standard string search on TitlesTOC
               strTOC = CStr(.Fields(0).Value)
               strTest = Replace$(strSearch, "*", "")
               strTest = Replace$(strTest, Chr$(34), "")
               strAttrib = ""
               'Case-sensitive search
               Do While InStr(strTOC, UCase$(strTest)) > 0
                  intPos = InStr(strTOC, UCase$(strTest))
                  Do Until Mid$(strTOC, intPos, 2) = vbCrLf
                     intPos = intPos - 1
                  Loop
                  strItem = Mid$(strTOC, intPos + 2)
                  strItem = Trim$(Left$(strItem, InStr(strItem, vbCrLf) - 1))
                  'It's a title
                  strId = Left$(strItem, InStr(strItem, " ") - 1)
                  strAttrib = "ti" & strId & "st_"
                  colTitles.Add strAttrib & ";" & strItem
                  strHits = strHits & strAttrib & ";" & strItem & vbCrLf
                  intHits = intHits + 1
                  'Find the next instance, if present
                  strTOC = Mid$(strTOC, InStr(UCase$(strTOC), UCase$(strTest)) + Len(strTest))
               Loop
            End If
         End If
      End With
   Next intLevel
   sngTime = Timer - sngTime
   
   'Release the connection
   Set rstSearch = Nothing
   Set cmmCFR = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         Close
      End If
   End With
   Set cnnCFR = Nothing
   
   'The XML header
   strXML = strXMLPrefix & strCFRSearch
   
   Select Case intMaxLevel
      Case 2
         strLevel = "Titles"
         strTableCols = "2:Title:Title Name"
      Case 3
         strLevel = "Subtitles"
         strTableCols = "3:Title:Subt.:Subtitle or Title Name"
      Case 4
         strLevel = "Chapters"
         strTableCols = "4:Title:Subt.:Chapter:Chapter, Subtitle, or Title Name"
      Case 5
         strLevel = "Subchapters"
         strTableCols = "5:Title:Subt.:Chapter:Subc.:Subchapter, Chapter, Subtitle or Title Name"
      Case 6
         strLevel = "Parts"
         strTableCols = "6:Title:Subt.:Chapter:Subchapter:Part:Part, Subchapter, Chapter, Subtitle or Title Name"
      Case 7
         strLevel = "Sections"
         If intMinLevel = 7 Or (blnIsMax And strTable = "Sections") Then
            'If only sections are returned, use the short form
            strTableCols = "4:Title:Part:Section:Section Name"
         Else
            strTableCols = "7:Title:Subt.:Chapter:Subc.:Part:Sect.:Section, Part, Subchapter, Chapter, Subtitle or Title Name"
         End If
   End Select
   
   'Start of header elements
   strXML = strXML & "   <Header>" & vbCrLf & Space$(6) & "<Head>" & _
      "Full-Text Search of the XML Version of the Electronic CFR (eCFR Beta)</Head>" & _
      vbCrLf & Space$(6) & "<Level>"
   If intMinLevel = 6 And intMaxLevel = 7 Then
      strXML = strXML & "Searching in CFR section text"
   Else
      strXML = strXML & "Starting at the " & strLevel & " level in the eCFR Table of Contents"
   End If
   If Len(strTitleID) > 0 Then
      strXML = strXML & "</Level>" & vbCrLf & _
         Space$(6) & "<Search>" & "Searching for [" & strSearch & _
         "] in Title " & strTitleID & " with a limit of " & CStr(intLimit) & " elements</Search>" & _
         vbCrLf & Space$(6) & "<Result>"
   Else
      strXML = strXML & "</Level>" & vbCrLf & _
         Space$(6) & "<Search>" & "Searching for [" & strSearch & _
         "] with a limit of " & CStr(intLimit) & " elements</Search>" & _
         vbCrLf & Space$(6) & "<Result>"
   End If
   If intHits = 0 Then
      strXML = strXML & "Your search term found no matching elements"
   Else
      strXML = strXML & "Your search returned " & CStr(intHits) & " elements from "
      If intMinLevel = 6 And intMaxLevel = 7 Then
         strXML = strXML & Format$(CStr(lngSectItems), "#,###,##0")
      ElseIf intMaxLevel = 7 Then
         strXML = strXML & Format$(CStr(lngSectItems + lngTOCItems), "###,##0")
      Else
         strXML = strXML & Format$(CStr(lngTOCItems), "###,##0")
      End If
      strXML = strXML & " records in " & Format$(CStr(sngTime), "#0.00") & " seconds"
   End If
   strXML = strXML & "</Result>" & vbCrLf & Space$(6) & "<ColHeads>" & strTableCols & "</ColHeads>"
   strXML = strXML & vbCrLf & Space$(3) & "</Header>" & vbCrLf
   
   'Work backward through the collections
   For intLevel = 6 To 1 Step -1
      Select Case intLevel
         Case 1
            Set colSearch = colTitles
            strLevel = "Title"
         Case 2
            Set colSearch = colSubtitles
            strLevel = "Subtitle"
         Case 3
            Set colSearch = colChapters
            strLevel = "Chapter"
         Case 4
            Set colSearch = colSubchapters
            strLevel = "Subchapter"
         Case 5
            Set colSearch = colParts
            strLevel = "Part"
         Case 6
            Set colSearch = colSections
            strLevel = "Section"
      End Select

      intHits = 0
      intPos = 6
      With colSearch
         If .Count > 0 Then
            If Not blnHasBody Then
                strXML = strXML & "   <Body>" & vbCrLf
                blnHasBody = True
            End If
            strXML = strXML & Space$(6) & "<" & strLevel & "s>" & vbCrLf
            For intCtr = 1 To .Count
               strAttrib = Left$(.Item(intCtr), InStr(.Item(intCtr), ";") - 1)
               strItem = Mid$(.Item(intCtr), InStr(.Item(intCtr), ";") + 1)
               strXML = strXML & Space$(9) & "<" & strLevel & " id='" & strAttrib & "'>" & vbCrLf
               strXML = strXML & Space$(12) & strItem & vbCrLf
               strXML = strXML & Space$(9) & "</" & strLevel & ">" & vbCrLf
               intHits = intHits + 1
               If intHits >= intLimit Then
                  Exit For
               End If
            Next intCtr
            strXML = strXML & Space$(6) & "</" & strLevel & "s>" & vbCrLf
         Else
            intPos = intPos - 1
         End If
      End With
      If intHits >= intLimit Then
         Exit For
      End If
   Next intLevel
   
   If blnHasBody Then
      strXML = strXML & "   </Body>" & vbCrLf
   End If
   strXML = strXML & "</CFRSearch>" & vbCrLf
   If strSearchType = "XHTML" Then
      GetSearchResults = TransformXMLSearch(strXML)
   Else
      GetSearchResults = strXML
   End If
   GoTo SearchResultsExit
   
SearchResultsErr:
   GetSearchResults = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo SearchResultsExit

SearchResultsExit:
   'Clean up
   Set colTitles = Nothing
   Set colSubtitles = Nothing
   Set colChapters = Nothing
   Set colSubchapters = Nothing
   Set colParts = Nothing
   Set colSections = Nothing
   Set colSearch = Nothing
End Function

Private Function TransformXMLSearch(ByVal strDoc As String) As String
   'This transform is simpler than the other transforms, because the
   'XML document isn't hierarchical.
   Dim domDoc As New MSXML2.DOMDocument30
   Dim domNode As MSXML2.IXMLDOMNode
   Dim domNode1 As MSXML2.IXMLDOMNode
   Dim domNode2 As MSXML2.IXMLDOMNode
   Dim nodList As MSXML2.IXMLDOMNodeList
   
   Dim strText As String
   Dim strHTML As String
   Dim strReplace As String
   Dim strName As String
   Dim strData As String
   Dim strId As String
   Dim strWidthPct As String
   Dim strTableSpec As String
   Dim strCols As String
   Dim strTest1 As String
   Dim strTest2 As String
   
   Dim intNode As Integer
   Dim intCtr As Integer
   Dim intCol As Integer
      
   On Error GoTo TransfXMLSearchErr
   
   'Page header
   strText = "Full-Text Search of the U.S. Code of Federal Regulations"
   strHTML = strXMLPrefix & strXHTMLHeader & "   <head>" & vbCrLf & "      <title>" & vbCrLf
   strHTML = strHTML & Space$(9) & strText & vbCrLf & "      </title>" & vbCrLf
   strHTML = strHTML & Space$(6) & strCSSSearch & "   </head>" & vbCrLf
   strHTML = strHTML & "   <body>" & vbCrLf & "      <table width = '100%' border='0' cellpadding='0' cellspacing = '0' align='center'>" & vbCrLf
   strHTML = strHTML & Space$(9) & "<tr><td height='80px' width='70px' padding-left='0px' padding-right='0px'><img src='OakLeaf.gif' height='80px' width='70px' border='0' /></td>" & _
      "<td>OakLeaf Systems<br />Search Results from the Online U.S. Code of Federal Regulations Delivered by<br />" & _
      "An XML Web Service from <i>Visual Basic.NET XML Web Services Developer's Guide</i><br />" & _
      "Osborne/McGraw-Hill ISBN 0-07-222369-3 (To be published in Spring 2002)</td></tr>" & vbCrLf
   strHTML = strHTML & "      </table>" & vbCrLf
   strHTML = strHTML & "      <table width='100%' border='0' align='center'>" & vbCrLf
   strHTML = strHTML & Space$(9) & "<th colspan='2'>#Placeholder#</th>" & vbCrLf
   
   If InStr(strDoc, "ERROR:") Then
      strHTML = Replace$(strHTML, "#Placeholder#", "Click the Error Message Below to Return to the Search Page")
      strHTML = strHTML & Space$(9) & "<tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>" & vbCrLf
      strHTML = strHTML & Space$(12) & "<tr id='search'><td>ERROR!</td><td>" & Mid$(strDoc, InStr(strDoc, " ") + 1) & "</td></tr>" & vbCrLf
      strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf & Space$(6) & "</table>" & vbCrLf & "   </body>" & vbCrLf & "</html>"
      TransformXMLSearch = strHTML
      GoTo TransfXMLSearchExit
   End If
   
   domDoc.loadXML strDoc
   With domDoc
      .loadXML strDoc
      If .parseError.errorCode <> 0 Then
         'Records with undetected parse errors are present in the database
         TransformXMLSearch = "PARSE ERROR Code: " & CStr(.parseError.errorCode) & ", Line: " & CStr(.parseError.Line) & ", " & .parseError.reason & vbCrLf & "Can't load document into XML DOM"
         GoTo TransfXMLSearchExit
      End If
      'Working on the header table
      Set domNode = .childNodes(1).firstChild
   End With
   
   For intNode = 0 To domNode.childNodes.length - 1
      Set domNode1 = domNode.childNodes(intNode)         'Title
      strText = domNode1.firstChild.Text
      If intNode = 0 Then
         strHTML = Replace$(strHTML, "#Placeholder#", strText)
      ElseIf intNode = 4 Then
         strTableSpec = strText
      Else
         If intNode = 1 Then
            strName = "Level"
            strHTML = strHTML & Space$(12) & "<tr id='level' class='Normal'>" & vbCrLf
         ElseIf intNode = 2 Then
            strName = "Search"
            'Link to initial search page
            strHTML = strHTML & Space$(9) & "<tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>" & vbCrLf
            strHTML = strHTML & Space$(12) & "<tr id='search' class='Normal'>" & vbCrLf
         Else
            strName = "Result"
            strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf
            strHTML = strHTML & Space$(12) & "<tr id='result' class='Normal'>" & vbCrLf
         End If
         strHTML = strHTML & Space$(15) & "<td>" & strName & "</td>"
         If intNode = 2 Then
            strHTML = strHTML & "<td>" & strText & " (Click for New Search)</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
         Else
            strHTML = strHTML & "<td>" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
         End If
      End If
   Next intNode
   
   strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf & Space$(6) & "</table>" & vbCrLf
   Set domNode = domDoc.childNodes(1)
   If domNode.childNodes.length > 1 Then
      'There's a body, get the colspan for the header
      strCols = Left$(strTableSpec, 1)
      strTableSpec = Mid$(strTableSpec, 3)
      
      strText = "Elements in Decreasing Order of Specificity (Click an Item Below to Return "
      If InStr(strTableSpec, "Sect.") > 0 Or InStr(strTableSpec, "Section") > 0 Then
         If CInt(strCols) > 4 Then
            strText = strText & "Section Text or TOC)"
         Else
            strText = strText & "Section Text)"
         End If
      Else
         strText = strText & "Table of Contents)"
      End If
      
      strHTML = strHTML & Space$(6) & "<table>" & vbCrLf
      strHTML = strHTML & Space$(9) & "<th colspan='" & strCols & "'>" & strText & "</th>" & vbCrLf
      strHTML = strHTML & Space$(12) & "<tr class='Header'>" & vbCrLf
      
      'Get the subheadings
      Do While InStr(strTableSpec, ":") > 0
         strName = Left$(strTableSpec, InStr(strTableSpec, ":") - 1)
         strHTML = strHTML & Space$(15) & "<td width='5%'>" & strName & "</td>" & vbCrLf
         If InStr(strTableSpec, ":") > 0 Then
            strTableSpec = Mid$(strTableSpec, InStr(strTableSpec, ":") + 1)
         End If
      Loop
      
      strHTML = strHTML & Space$(15) & "<td align='center'>" & strTableSpec & "</td>" & vbCrLf
      strHTML = strHTML & Space$(12) & "</tr>" & vbCrLf
      strHTML = strHTML & Space$(9) & "<tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>" & vbCrLf
      
      For intCtr = 1 To 6
         Select Case intCtr
            Case 1
               strName = "Section"
            Case 2
               strName = "Part"
            Case 3
               strName = "Subchapter"
            Case 4
               strName = "Chapter"
            Case 5
               strName = "Subtitle"
            Case 6
               strName = "Title"
         End Select
         Set nodList = domDoc.getElementsByTagName(strName)
         
         If nodList.length > 0 Then
            For intNode = 0 To nodList.length - 1
               Set domNode2 = nodList.Item(intNode)
               strId = domNode2.Attributes(0).Text
               strText = domNode2.Text
               strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='Normal'>" & vbCrLf
               For intCol = 1 To CInt(strCols) - 1
                  'Pick apart the id, which always has a title
                  Select Case intCol
                     Case 1
                        strTest1 = "ti"
                        If strCols = "4" And InStr(strId, "sn") > 0 Then
                           strTest2 = "pn"
                        Else
                           strTest2 = "st"
                        End If
                     Case 2
                        If strCols = "4" And InStr(strId, "sn") > 0 Then
                           strTest1 = "pn"
                           strTest2 = "sn"
                        Else
                           strTest1 = "st"
                           strTest2 = "ch"
                        End If
                     Case 3
                        If strCols = "4" And InStr(strId, "sn") > 0 Then
                           strTest1 = "sn"
                           strTest2 = ""
                        Else
                           strTest1 = "ch"
                           strTest2 = "sc"
                        End If
                     Case 4
                        strTest1 = "sc"
                        strTest2 = "pn"
                     Case 5
                        strTest1 = "pn"
                        strTest2 = "sn"
                     Case 6
                        strTest1 = "sn"
                        strTest2 = ""
                  End Select
                  
                  If InStr(strId, strTest1) > 0 Then
                     If InStr(strId, "sn") > 0 And intCol = 1 Then
                        strTest2 = "pn"
                     End If
                     strData = Mid$(strId, InStr(strId, strTest1) + 2)
                     If Len(strTest2) > 0 Then
                        If InStr(strData, strTest2) > 0 Then
                           If InStr(strData, "sn") = 0 Then
                              strData = Left$(strData, InStr(strData, strTest2) - 1)
                           ElseIf InStr(strData, "sn") > 0 And ((intCol = 1 Or intCol > 4) Or strCols = 4) Then
                              strData = Left$(strData, InStr(strData, strTest2) - 1)
                           Else
                              strData = "-"
                           End If
                        End If
                     End If
                  Else
                     strData = "-"
                  End If
                  
                  strData = Replace$(strData, "_", "-")
                  strHTML = strHTML & Space$(15) & "<td id='" & strTest1 & strData & "' align='center'>"
                  If strTest1 = "ch" And InStr(strId, "sn") = 0 Then
                     'Use the Roman numerals as the data
                     If strData <> "-" Then
                        strData = Arabic2Roman(CInt(strData))
                     End If
                  End If
                  strHTML = strHTML & strData & "</td>" & vbCrLf
               Next intCol
               strText = Trim$(Mid$(strText, InStr(strText, " - ") + 3))
               strHTML = strHTML & Space$(15) & "<td id='" & strId & "' align='left'>" & strText & "</td>" & vbCrLf
               strHTML = strHTML & Space$(12) & "</tr>" & vbCrLf
            Next intNode
         End If
      Next intCtr
      strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf & Space$(6) & "</table>" & vbCrLf
   End If
   strHTML = strHTML & "   </body>" & vbCrLf & "</html>"
   TransformXMLSearch = strHTML
   GoTo TransfXMLSearchExit
   
TransfXMLSearchErr:
   TransformXMLSearch = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo TransfXMLSearchExit

TransfXMLSearchExit:
   'Dismantle the objects
   Set domDoc = Nothing
   Set domNode = Nothing
   Set domNode1 = Nothing
   Set domNode2 = Nothing
   Set nodList = Nothing
End Function

Private Function Arabic2Roman(ByVal intNum As Integer) As String
    'Convert numeric chapter IDs into Roman numerals

    Dim strArabic(12) As Integer
    Dim strRoman(12) As String
    Dim intCtr As Integer
    Dim strRom As String

    strArabic(0) = 1000
    strArabic(1) = 900
    strArabic(2) = 500
    strArabic(3) = 400
    strArabic(4) = 100
    strArabic(5) = 90
    strArabic(6) = 50
    strArabic(7) = 40
    strArabic(8) = 10
    strArabic(9) = 9
    strArabic(10) = 5
    strArabic(11) = 4
    strArabic(12) = 1
    strRoman(0) = "M"
    strRoman(1) = "CM"
    strRoman(2) = "D"
    strRoman(3) = "CD"
    strRoman(4) = "C"
    strRoman(5) = "XC"
    strRoman(6) = "L"
    strRoman(7) = "XL"
    strRoman(8) = "X"
    strRoman(9) = "IX"
    strRoman(10) = "V"
    strRoman(11) = "IV"
    strRoman(12) = "I"

    intCtr = 0
    Do While intNum
        Do While intNum >= strArabic(intCtr)
            intNum = intNum - strArabic(intCtr)
            strRom = strRom + strRoman(intCtr)
        Loop
        intCtr = intCtr + 1
    Loop
    Arabic2Roman = strRom
End Function

