VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFRSect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private cnnCFR As New ADODB.Connection
Private cmmCFR As New ADODB.Command
Private rstClient As New ADODB.Recordset
Private strSQL As String
Private bln2ndPass As Boolean

'DOCTYPE declaration won't parse
'Private Const strXHTMLHeader As String = "<!DOCTYPE html " & vbCrLf & _
'"   PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'" & vbCrLf & _
'"   'DTD/xhtml1-strict.dtd' >" & vbCrLf & _
'"<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf
Private Const strXHTMLHeader As String = "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf
Private Const strXMLPrefix As String = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & vbCrLf
Private Const strCSSSect As String = "<link rel='stylesheet' href='CFRSect.css' type='text/css' />" & vbCrLf
Private Const blnUseHTC As Boolean = True

Public Function GetSectById(ByVal strConnect As String, _
                            ByVal strDocType As String, _
                            ByVal strID As String) As String
   
   'Translate the ID string from the TOC to GetSection arguments
   'Only the title, part, and section IDs are used (ti#pn#sn#)
   Dim strTitleID As String
   Dim strSubtitleID As String
   Dim strChapterID As String
   Dim strSubchapterID As String
   Dim strPartID As String
   Dim strSectionID As String
   Dim strTest As String
      
   'Extract the title, part and section IDs from the long- or short-form ID
   If InStr(strID, "ti") > 0 Then
      strTitleID = Mid$(strID, InStr(strID, "ti") + 2)
      If InStr(strID, "pn") > 0 Then
         If InStr(strID, "st") > 0 Then
            'It's long-form
            strTitleID = Left$(strTitleID, InStr(strTitleID, "st") - 1)
         Else
            'It's short-form
            strTitleID = Left$(strTitleID, InStr(strTitleID, "pn") - 1)
         End If
         strPartID = Mid$(strID, InStr(strID, "pn") + 2)
         If InStr(strID, "sn") > 0 Then
            strPartID = Left$(strPartID, InStr(strPartID, "sn") - 1)
            strSectionID = Mid$(strID, InStr(strID, "sn") + 2)
         Else
            'error
         End If
      Else
         'error
      End If
   Else
      'error
   End If
   
   GetSectById = GetSection(strConnect, strTitleID, strPartID, strSectionID, strDocType)
End Function

Public Function GetSection(ByVal strConnect As String, _
                           ByVal strTitleID As String, _
                           ByVal strPartID As String, _
                           ByVal strSectionID As String, _
                           ByVal strDocType As String) As String
   
   'Get the section XML document
   Dim strDoc As String
   Dim strError As String
   
   On Error GoTo GetSectErr
   GetSection = "ERROR: Unspecified Error"
   
   With cnnCFR
      If .State = adStateClosed Then
         'Open the connection
         .CommandTimeout = 300
         .Open strConnect
         'Define a Command object
         Set cmmCFR.ActiveConnection = cnnCFR
      End If
   End With
   
   'Retrieve section from database
   strSQL = "SELECT SectChar, ParseError FROM Sections WHERE TitleID = " & strTitleID & _
      " AND PartID = '" & strPartID & "' AND SectionID = '" & strSectionID & "'"
   
   'Two passes are required: First pass checks SectChar; if null, checks SectText
   bln2ndPass = False
   Do
      With rstClient
         If .State = adStateOpen Then
            Close
         End If
      End With
      Set rstClient = cnnCFR.Execute(strSQL, , adCmdText)
      With rstClient
         If .EOF Then
            strError = "ERROR: Citation " & strTitleID & "CFR" & _
            strPartID & "." & strSectionID & " was not found in the database."
            .Close
            If strDocType = "XHTML" Then
               GetSection = TransformXMLSect(strError, strSectionID)
            Else
               GetSection = strError
            End If
            GoTo GetSectErr
         Else
            If IsNull(.Fields(0).Value) Then
               If bln2ndPass Then
                  .Close
                  strError = "ERROR: The text of citation " & strTitleID & "CFR" & _
                     strPartID & "." & strSectionID & " has not been retrieved from " & _
                     "the eCFR database."
                  If strDocType = "XHTML" Then
                     GetSection = TransformXMLSect(strError, strSectionID)
                  Else
                     GetSection = strError
                  End If
                  GoTo GetSectErr
               End If
               If InStr(strSQL, "SectChar") > 0 Then
                  strSQL = Replace$(strSQL, "SectChar", "SectText")
                  bln2ndPass = True
               Else
                  Exit Do
               End If
            ElseIf .Fields(1).Value = True Then
               'Some early entries are missing a CDATA section for URLs
               .Close
               strError = "ERROR: The XML document for citation " & strTitleID & "CFR" & _
                  strPartID & "." & strSectionID & " has a parse error."
               If strDocType = "XHTML" Then
                  GetSection = TransformXMLSect(strError, strSectionID)
               Else
                  GetSection = strError
               End If
               GoTo GetSectExit
            Else
               If strDocType = "XML" Then
                  GetSection = strXMLPrefix & CStr(.Fields(0).Value)
                  .Close
                  GoTo GetSectExit
               Else
                  strDoc = strXMLPrefix & CStr(.Fields(0).Value)
               End If
               Exit Do
            End If
         End If
      End With
   Loop
   
   'Close the database objects early
   With rstClient
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstClient = Nothing
   Set cmmCFR = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCFR = Nothing
   
   If Len(strDoc) > 100 Then
      GetSection = "ERROR: Section document not found."
   End If
   GetSection = TransformXMLSect(strDoc, strSectionID)
   GoTo GetSectExit

GetSectErr:
   GetSection = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo GetSectExit
   
GetSectExit:
   'Make sure data objects are closed
   With rstClient
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstClient = Nothing
   Set cmmCFR = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCFR = Nothing
End Function

Private Function TransformXMLSect(ByVal strDoc As String, _
                                  ByVal strSectionID As String) As String
   'Transform the XML document to XHTML
                                  
   Dim domDoc As New MSXML2.DOMDocument30
   Dim domNode As MSXML2.IXMLDOMNode
   Dim domNode2 As MSXML2.IXMLDOMNode
   Dim domNode3 As MSXML2.IXMLDOMNode
   Dim domNode4 As MSXML2.IXMLDOMNode
   
   Dim strHTML As String
   Dim strName As String
   Dim strID As String
   Dim strText As String
   Dim strTemp As String
   Dim strURL As String
   Dim strHilite As String
   
   Dim intCtr As Integer
   Dim intNode As Integer
   Dim intPos As Integer
   
   On Error GoTo TransfXMLSectErr
   
   strHilite = "onmouseover=""this.style.color='#266294'; this.style.textDecoration='underline'"" " & _
      "onmouseout=""this.style.color='black'; this.style.textDecoration=''"""
   
   strHTML = strXMLPrefix & strXHTMLHeader & "   <head>" & vbCrLf & "      <title>" & vbCrLf
   If InStr(strDoc, "ERROR:") > 0 Then
      'Trap section parse and missing errors
      strText = "Section Error Reported by the CFR Database"
      strHTML = strHTML & Space$(6) & strText & vbCrLf & "      </title>" & vbCrLf
      strHTML = strHTML & Space$(6) & strCSSSect & "   </head>" & vbCrLf
      strHTML = strHTML & "   <body>" & vbCrLf & "      <table width='100%' border='0' cellpadding='0' cellspacing = '0' align='center'>" & vbCrLf
      strHTML = strHTML & Space$(9) & "<tr><td height='80px' width='70px' padding-left='0px' padding-right='0px'><img src='OakLeaf.gif' height='80px' width='70px' border='0' /></td>" & _
         "<td>OakLeaf Systems<br />Sections of the Online U.S. Code of Federal Regulations Delivered by<br />" & _
         "An XML Web Service from <i>Visual Basic.NET XML Web Services Developer's Guide</i><br />" & _
         "Osborne/McGraw-Hill ISBN 0-07-222369-3 (To be published in Spring 2002)</td></tr>" & vbCrLf
      strHTML = strHTML & "      </table>" & vbCrLf
      strHTML = strHTML & "      <table width='100%' border='0' align='center'>" & vbCrLf
      strText = strText & " (Click Your Browser's Back Button)"
      strHTML = strHTML & Space$(9) & "<th colspan='2'>" & strText & "</th>" & vbCrLf
      strHTML = strHTML & Space$(9) & "<tr><td>ERROR</td><td>" & Mid$(strDoc, InStr(strDoc, " ") + 1) & "</td></tr>" & vbCrLf
      strHTML = strHTML & Space$(9) & "<tr><td></td><td>Please select a different section (error correction is in process)</td></tr>" & vbCrLf
      strHTML = strHTML & Space(6) & "</table>" & vbCrLf
      strHTML = strHTML & "   </body>" & vbCrLf & "</html>"
      TransformXMLSect = strHTML
      GoTo TransfXMLSectExit
   End If
   
   domDoc.loadXML strDoc
   With domDoc
      .loadXML strDoc
      If .parseError.errorCode <> 0 Then
         'Records with undetected parse errors are present in the database
         TransformXMLSect = "PARSE ERROR Code: " & CStr(.parseError.errorCode) & ", Line: " & CStr(.parseError.Line) & ", " & .parseError.reason & vbCrLf & "Can't load document into XML DOM"
         GoTo TransfXMLSectExit
      End If
      'Get the Header node
      Set domNode = .childNodes(1).firstChild
      With domNode
         If .nodeName = "Header" Then
            For intCtr = 0 To .childNodes.length - 1
               strName = .childNodes(intCtr).nodeName
               strText = .childNodes(intCtr).Text
               'TITLE not present but eCFR might add it later for consistency
               strText = Replace$(strText, "TITLE ", "")
               strText = Replace$(strText, "Subtitle ", "")
               strText = Replace$(strText, "Chapter ", "")
               strText = Replace$(strText, "SUBCHAPTER ", "")
               If Left$(strSectionID, 3) = "App" And InStr(strText, "Appendix") > 0 Then
                  'Leave "Part" and "Subpart" in the title
               Else
                  'Remove them
                  strText = Replace$(strText, "Part ", "")
                  strText = Replace$(strText, "Subpart ", "")
               End If
               strText = Replace$(strText, "Sec. ", "")
               
               'Create the id tag
               Select Case strName
                  Case "Title"
                     If InStr(strText, "--") > 0 Then
                        'Special case for a few sections
                        strText = Replace$(strText, "--", " ")
                     End If
                     strID = "ti" & Left$(strText, InStr(strText, " ") - 1) & "st_"
                     strName = UCase$(strName)
                  Case "Subtitle"
                     If Len(strText) > 0 Then
                        strID = Replace$(strID, "st_", "st" & Left$(strText, InStr(strText, " ") - 1))
                     End If
                  Case "Chapter"
                     If Len(strText) > 0 Then
                        strID = strID & "ch" & CStr(Roman2Arabic(Left$(strText, InStr(strText, " ") - 1))) & "sc_"
                     Else
                        'Occurs in Title 7A (parts, no chapters)
                        strID = strID & "ch0sc_"
                     End If
                  Case "Subchapter"
                     If Len(strText) > 0 Then
                        strID = Replace$(strID, "sc_", "sc" & Left$(strText, InStr(strText, " ") - 1))
                     End If
                     strName = UCase$(strName)
                  Case "Part"
                     strID = strID & "pn" & Left$(strText, InStr(strText, " ") - 1)
                  Case "Section"
                     If InStr(strText, ".") > 0 Then
                        strTemp = Left$(strText, InStr(strText, " ") - 1)
                        strTemp = Mid$(strTemp, InStr(strTemp, ".") + 1)
                     Else
                        'It's an appendix
                        strTemp = strSectionID
                     End If
                     strID = strID & "sn" & strTemp
               End Select
                              
               'Add the table rows
               If intCtr = 0 Then
                  strHTML = strHTML & Space$(6) & strText & vbCrLf & "      </title>" & vbCrLf
                  strHTML = strHTML & Space$(6) & strCSSSect & "   </head>" & vbCrLf
                  strHTML = strHTML & "   <body>" & vbCrLf & "      <table width='100%' border='0' cellpadding='0' cellspacing = '0' align='center'>" & vbCrLf
                  strHTML = strHTML & Space$(9) & "<tr><td height='80px' width='70px' padding-left='0px' padding-right='0px'><img src='OakLeaf.gif' height='80px' width='70px' border='0' /></td>" & _
                     "<td>OakLeaf Systems<br />Sections of the Online U.S. Code of Federal Regulations Delivered by<br />" & _
                     "An XML Web Service from <i>Visual Basic.NET XML Web Services Developer's Guide</i><br />" & _
                     "Osborne/McGraw-Hill ISBN 0-07-222369-3 (To be published in Spring 2002)</td></tr>" & vbCrLf
                  strHTML = strHTML & "      </table>" & vbCrLf
                  strHTML = strHTML & "      <table width='100%' border='0' align='center'>" & vbCrLf
                  strHTML = strHTML & Space$(9) & "<th colspan='2'>" & strText & "</th>" & vbCrLf
               Else
                  If Len(strText) > 0 Then
                     If blnUseHTC Then
                        'Enable behavior only for TOC items (permits use of a single .htc file for sections and TOCs)
                        If intCtr = 3 Then
                           'Table body starts at title
                           strHTML = strHTML & Space$(9) & "<tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>" & vbCrLf
                        End If
                     End If
                     If intCtr < 3 Or intCtr > 7 Then
                        strHTML = strHTML & Space$(12) & "<tr id='noTag' valign='top'><td>"
                        strHTML = strHTML & strName & "</td><td>"
                        strHTML = strHTML & strText & "</td></tr>" & vbCrLf
                     Else
                        If blnUseHTC Then
                           strHTML = strHTML & Space$(12) & "<tr id='" & strID & "' valign='top'><td>"
                           strHTML = strHTML & strName & "</td><td>"
                           strHTML = strHTML & strText & "</td></tr>" & vbCrLf
                           If strName = "Part" Then
                              'End table body after part
                               strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf
                           End If
                        Else
                           strHTML = strHTML & Space$(12) & "<tr id='" & strID & "' " & strHilite & " valign='top'>" & vbCrLf
                           strHTML = strHTML & Space$(15) & "<td>" & strName & "</td><td>"
                           strHTML = strHTML & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
                        End If
                     End If
                  End If
               End If
            Next intCtr
            If Not blnUseHTC Then
               strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf
            End If
            strHTML = strHTML & "      </table><br />" & vbCrLf
         Else
            'error
         End If
      End With
      For intCtr = 1 To .childNodes(1).childNodes.length - 1
         'Child nodes are Body (required) and optional Extract
         Set domNode = .childNodes(1).childNodes(intCtr)
         With domNode
            If .nodeName = "Body" Then
               strHTML = strHTML & Space$(6) & "<div class='Body'>" & vbCrLf
               If .hasChildNodes Then
                  'Presumably Para1, which has all the body text,
                  'but there might be multiple Para1 nodes
                  For intNode = 0 To .childNodes.length - 1
                     strName = .childNodes(0).nodeName
                     strText = .childNodes(0).Text
                     If Len(strText) > 0 Then
                        If Left(strText, 1) = "(" Then
                           'Para1 has no text, and it's a Para2 or lower
                           strTemp = Space$(12)
                        Else
                           strTemp = Space$(9)
                        End If
                        strText = strTemp & strText
                        'Detect the level by the indents (easier than walking nodes as done below)
                        If InStr(strText, vbLf) > 0 Then
                           'Detect stray LFs within the text
                           If Mid$(strText, InStr(strText, vbLf) + 3, 1) <> " " Then
                              'Replace the linefeed with a space (a definite hack)
                              strText = Trim$(Left$(strText, InStr(strText, vbLf) - 1) & " " & Mid$(strText, InStr(strText, vbLf) + 1))
                              If InStr(strText, strTemp) > 0 Then
                                 'It's missing a LF in the text
                                 strText = Trim$(strText)
                                 strText = strTemp & Left$(strText, InStr(strText, strTemp) - 1) & vbLf & Mid$(strText, InStr(strText, strTemp))
                              End If
                           End If
                           If Right(strText, 1) <> vbLf Then
                              'Add a LF to get the last paragraph
                              strText = strText & vbLf
                           End If
                           Do While InStr(strText, vbLf) > 0
                              strTemp = Left$(strText, InStr(strText, vbLf) - 1)
                              'Remove 6 spaces, if present (bug fix 9/28/01)
                              If Left$(strTemp, 6) = Space$(6) Then
                                 strTemp = Mid$(strTemp, 7)
                              End If
                              intPos = 0
                              Do While Left(strTemp, 1) = " "
                                 strTemp = Mid$(strTemp, 2)
                                 intPos = intPos + 1
                              Loop
                              If Len(Trim$(strTemp)) = 0 Then
                                 'Stop
                              Else
                                 intPos = intPos \ 3
                                 strHTML = strHTML & Space$(9) & "<p class='Para" & CStr(intPos) & "'>" & strTemp & "</p>" & vbCrLf
                              End If
                              strText = Mid$(strText, InStr(strText, vbLf) + 1)
                           Loop
                        Else
                           'There's only one chunk of text
                           strHTML = strHTML & Space$(9) & "<p class='Para1'>" & Trim$(strText) & "</p>" & vbCrLf
                        End If
                     Else
                        'Nada ai
                     End If
                  Next intNode
               Else
                  strHTML = strHTML & Space$(9) & "<p class='Para1'>(This section has no body text)</p>" & vbCrLf
               End If
               strHTML = strHTML & Space$(6) & "</div>" & vbCrLf
            ElseIf .nodeName = "Extract" Or .nodeName = "Exhibit" Then
               If .hasChildNodes Then
                  'It's a hierarchical extract or exhibit
                  '<hr> width is exactly equal to Para1 width only at 600x800
                  strHTML = strHTML & Space$(9) & "<hr width='95%' color='#266294' align='center' />" & vbCrLf
                  strHTML = strHTML & Space$(6) & "<div class='" & .nodeName & "'>" & vbCrLf
                  'Extracts can have heads and nested paragraphs or only text
                  For intNode = 0 To .childNodes.length - 1
                     strName = .childNodes(intNode).nodeName
                     'Add the trimmed spaces
                     strText = Space$(9) & .childNodes(intNode).Text
                     If Len(strText) > 0 Then
                        'In this case, you detect the level by the indents,
                        'but not whether they are heads
                        If InStr(strText, vbLf) > 0 Then
                           Do While InStr(strText, vbLf) > 0
                              strTemp = Left$(strText, InStr(strText, vbLf) - 1)
                              'Remove 6 spaces
                              strTemp = Mid$(strTemp, 7)
                              intPos = 0
                              Do While Left(strTemp, 1) = " "
                                 strTemp = Mid$(strTemp, 2)
                                 intPos = intPos + 1
                              Loop
                              intPos = intPos \ 3
                              If intPos = 2 Then
                                 'First level is always a Para1 or a Head#,
                                 'but not necessarily Head1
                                 Set domNode2 = .childNodes(intNode)
                                 If domNode2.hasChildNodes Then
                                    If domNode2.childNodes.length > 1 Then
                                       strName = domNode2.childNodes(1).nodeName
                                    End If
                                 End If
                              ElseIf intPos = 3 Then
                                 If Not domNode2 Is Nothing Then
                                    Set domNode3 = domNode2.childNodes(1)
                                    If domNode3.hasChildNodes Then
                                       If domNode3.childNodes.length > 1 Then
                                          strName = domNode3.childNodes(1).nodeName
                                       End If
                                    End If
                                 End If
                              ElseIf intPos = 4 Then
                                 If Not domNode3 Is Nothing Then
                                    Set domNode4 = domNode3.childNodes(1)
                                    If domNode4.hasChildNodes Then
                                       If domNode4.childNodes.length > 1 Then
                                          strName = domNode4.childNodes(1).nodeName
                                       End If
                                    End If
                                 End If
                              End If
                              strTemp = Trim$(strTemp)
                              If Len(strTemp) > 0 Then
                                 If Left$(strName, 4) = "Head" Or (.nodeName = "Exhibit" And Left$(strTemp, 7) = "Exhibit") Then
                                    'Set it bold
                                    strHTML = strHTML & Space$(9) & "<p class='Para" & CStr(intPos) & "'><b>" & strTemp & "</b></p>" & vbCrLf
                                 Else
                                    'Set it regular
                                    strHTML = strHTML & Space$(9) & "<p class='Para" & CStr(intPos) & "'>" & strTemp & "</p>" & vbCrLf
                                 End If
                              End If
                              'strText = Mid$(strText, InStr(strText, vbLf) + 1)
                              strText = Mid$(strText, InStr(strText, vbLf) + 1)
                           Loop
                        Else
                           strText = Trim$(strText)
                           If .nodeName = "Exhibit" And Left$(strText, 7) = "Exhibit" Then
                              strHTML = strHTML & Space$(9) & "<p class='Para1'><b>" & strText & "</b></p>" & vbCrLf
                           Else
                              strHTML = strHTML & Space$(9) & "<p class='Para1'>" & strText & "</p>" & vbCrLf
                           End If
                        End If
                     Else
                        'Nothing there
                     End If
                  Next intNode
                  strHTML = strHTML & Space$(6) & "</div>" & vbCrLf
               End If
            ElseIf .nodeName = "EndNote" Then
               If .hasChildNodes Then
                  'End notes have multiple nodes at one level (all Para1s)
                  strHTML = strHTML & Space$(9) & "<hr width='95%' color='#266294' align='center' />" & vbCrLf
                  strHTML = strHTML & Space$(6) & "<div class='EndNote'>" & vbCrLf
                  For intNode = 0 To .childNodes.length - 1
                     strName = .childNodes(intNode).nodeName
                     strText = .childNodes(intNode).Text
                     If Len(strText) > 0 Then
                        If InStr(strText, vbLf) > 0 Then
                           Do While InStr(strText, vbLf) > 0
                              strTemp = Left$(strText, InStr(strText, vbLf) - 1)
                              If InStr(strTemp, "table(s) removed") > 0 Or InStr(strTemp, "to format as XML") > 0 Then
                                 'Check for a URL and add an anchor for direct access to
                                 If InStr(strText, "http://ecfr") > 0 And InStr(strHTML, "http://ecfr") = 0 Then
                                    strURL = Mid$(strText, InStr(strText, "http:"))
                                    If InStr(strURL, vbCrLf) > 0 Then
                                       strURL = Left$(strURL, InStr(strURL, vbCrLf) - 1)
                                    ElseIf InStr(strURL, vbLf) > 0 Then
                                       strURL = Left$(strURL, InStr(strURL, vbLf) - 1)
                                    End If
                                    'Temporary for test: The replace below doesn't appear to work
                                    'Fixups for earlier problems - Get HTML, not SGML
                                    'strURL = Replace$(strURL, "?DB=0&", "?DB=1&")
                                    'strURL = Replace$(strURL, "ViewNative", "View")
                                    'Check the reason for the trailing " in Sections class
                                    'Wrapping URLs in CDATA sections doesn't work in IE 5.5
                                    strURL = Replace$(strURL, Chr$(34), "")
                                    strTemp = "Click to retrieve section with missing HTML table or other content directly from the eCFR database"
                                    strHTML = strHTML & Space$(9) & "<a class='Para1' href='" & strURL & "'>" & strTemp & "</a>" & vbCrLf
                                 Else
                                    strHTML = strHTML & Space$(9) & "<p class='Para1'>" & strTemp & "</p>" & vbCrLf
                                 End If
                              Else
                                 If Len(Trim$(strTemp)) > 0 Then
                                    strHTML = strHTML & Space$(9) & "<p class='Para1'>" & strTemp & "</p>" & vbCrLf
                                 End If
                              End If
                              'There are two linefeeds ??
                              'strText = Mid$(strText, InStr(strText, vbLf) + 1)
                              strText = Mid$(strText, InStr(strText, vbLf) + 1)
                           Loop
                        Else
                           strHTML = strHTML & Space$(9) & "<p class='Para1'>" & strText & "</p>" & vbCrLf
                        End If
                     End If
                  Next intNode
                  strHTML = strHTML & Space$(6) & "</div>" & vbCrLf
               End If
            ElseIf .nodeName = "FedReg" Then
               strHTML = strHTML & Space$(9) & "<hr width='95%' color='#266294' align='center' />" & vbCrLf
               strHTML = strHTML & Space$(6) & "<div class='FedReg'>" & vbCrLf
               strHTML = strHTML & Space$(9) & "<p class='Para1'><b>Federal Register:</b> " & Mid$(.Text, 2, Len(.Text) - 2) & "</p>" & vbCrLf
               strHTML = strHTML & Space$(6) & "</div>" & vbCrLf
            End If
         End With
      Next intCtr
   End With
   'Terminate the page with a horizontal rule
   strHTML = strHTML & Space$(6) & "<hr width='95%' color='#266294' align='center' />" & vbCrLf
   strHTML = strHTML & "   </body>" & vbCrLf & "</html>"
   
   With domDoc
      'Test for parse errors
      If InStr(strDoc, "http:") = 0 Then
         'Don't parse documents with URLs having ampersands
         .loadXML strHTML
         If .parseError.errorCode <> 0 Then
            strHTML = "PARSE ERROR Code: " & CStr(.parseError.errorCode) & ", Line: " & CStr(.parseError.Line) & ", " & .parseError.reason & vbCrLf & strHTML
         End If
      End If
   End With
   
   TransformXMLSect = strHTML
   GoTo TransfXMLSectExit
   
TransfXMLSectErr:
   TransformXMLSect = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo TransfXMLSectExit

TransfXMLSectExit:
   'GC handles cleanup in VB.NET
   Set domDoc = Nothing
   Set domNode = Nothing
   Set domNode2 = Nothing
   Set domNode3 = Nothing
   Set domNode4 = Nothing
End Function

Private Function Roman2Arabic(ByVal strRomNum As String) As Long
   'Convert Roman chapter numbers to Arabic
   Dim strPrevChar As String
   Dim strCurrChar As String
   Dim strNextChar As String
   Dim lngSize As Long
   Dim intCtr As Integer

   For intCtr = 1 To Len(strRomNum) Step 2
      strCurrChar = Mid(strRomNum, intCtr, 1)
      strNextChar = Mid(strRomNum, intCtr + 1, 1)
      On Local Error Resume Next
      strPrevChar = IIf(intCtr = 1, " ", Mid(strRomNum, intCtr - 1, 1))
      On Error GoTo 0
      If NumeralValue(strNextChar) > NumeralValue(strCurrChar) Then
         lngSize = lngSize + (NumeralValue(strNextChar) - NumeralValue(strCurrChar))
      Else
         lngSize = lngSize + NumeralValue(strCurrChar)
      intCtr = intCtr - 1
      End If
   Next intCtr
   Roman2Arabic = lngSize
End Function

Private Function NumeralValue(ByVal strNumeral As String) As Long
   'Helper function for Roman2Arabic
   Select Case strNumeral
      Case "I"
         NumeralValue = 1
      Case "V"
         NumeralValue = 5
      Case "X"
         NumeralValue = 10
      Case "L"
         NumeralValue = 50
      Case "C"
         NumeralValue = 100
      Case "D"
         NumeralValue = 500
      Case "M"
         NumeralValue = 1000
   End Select
End Function

