VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFRToc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private cnnCFR As New ADODB.Connection
Private cmmCFR As New ADODB.Command

Private bln2ndPass As Boolean
Private rstClient As New ADODB.Recordset

'DOCTYPE declaration won't parse
'Private Const strXHTMLHeader As String = "<!DOCTYPE html " & vbCrLf & _
'"   PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'" & vbCrLf & _
'"   'DTD/xhtml1-strict.dtd' >" & vbCrLf & _
'"<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf
Private Const strXMLPrefix As String = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & vbCrLf
Private Const strXHTMLHeader As String = "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='en' >" & vbCrLf
Private Const strCSSToc As String = "<link rel='stylesheet' href='CFRToc.css' type='text/css' />" & vbCrLf

Public Function GetTocById(ByVal strConnect As String, _
                           ByVal strURL As String, _
                           ByVal strTOCType As String, _
                           ByVal strId As String) As String
   'Translate the Id string to GetTocByLevel arguments
   'Sending an empty Id string or "ti0" returns the Titles TOC
   Dim strTitleID As String
   Dim strSubtitleId As String
   Dim strChapterId As String
   Dim strSubchapterId As String
   Dim strPartID As String
   Dim strTest As String
         
   'Error processing not implemented
   
   If InStr(strId, "ti") > 0 Then
      strTitleID = Mid$(strId, InStr(strId, "ti") + 2)
      If InStr(strId, "st") > 0 Then
         strTitleID = Left$(strTitleID, InStr(strTitleID, "st") - 1)
         strSubtitleId = Mid$(strId, InStr(strId, "st") + 2)
         If InStr(strId, "ch") > 0 Then
            strSubtitleId = Left$(strSubtitleId, InStr(strSubtitleId, "ch") - 1)
            strChapterId = Mid$(strId, InStr(strId, "ch") + 2)
            If InStr(strId, "sc") > 0 Then
               strChapterId = Left$(strChapterId, InStr(strChapterId, "sc") - 1)
               strSubchapterId = Mid$(strId, InStr(strId, "sc") + 2)
               If InStr(strId, "pn") > 0 Then
                  strSubchapterId = Left$(strSubchapterId, InStr(strSubchapterId, "pn") - 1)
                  strPartID = Mid$(strId, InStr(strId, "pn") + 2)
               End If
            End If
         End If
      End If
   End If
   
   'Translate underscores to hyphens
   If strSubtitleId = "_" Then
      strSubtitleId = "-"
   End If
   If strSubchapterId = "_" Then
      strSubchapterId = "-"
   End If
   
   GetTocById = GetTocByLevel(strConnect, strTitleID, strSubtitleId, strChapterId, _
                              strSubchapterId, strPartID, strTOCType)
End Function

Public Function GetTocByLevel(ByVal strConnect As String, _
                              ByVal strTitleID As String, _
                              ByVal strSubtitleId As String, _
                              ByVal strChapterId As String, _
                              ByVal strSubchapterId As String, _
                              ByVal strPartID As String, _
                              ByVal strTOCType As String) As String
  'Return the TOC at the specified level
   Dim strDoc As String
   Dim strSQL As String
   
   On Error GoTo TocByLevelErr
   
   If Val(strTitleID) > 0 Then
      If Val(strPartID) > 0 Or strPartID = "0" Then
         'Parts level (there are some Part 0s
         strSQL = "SELECT TOCChar FROM Parts WHERE TitleID = " & _
            Val(strTitleID) & " AND PartID = '" & strPartID & "'"
      Else
         If Val(strChapterId) > 0 Then
            'Chapter level
            If Len(strSubchapterId) = 0 Or Trim$(strSubchapterId) = "-" Then
               strSQL = "SELECT TOCChar FROM Chapters WHERE TitleID = " & _
                  Val(strTitleID) & " AND SubtitleID = '" & strSubtitleId & _
                  "' AND ChapterID = '" & strChapterId & "'"
             Else
               'Subchapter level
               strSQL = "SELECT TOCChar FROM Subchapters WHERE TitleID = " & _
                  Val(strTitleID) & " AND SubtitleID = '" & strSubtitleId & _
                  "' AND ChapterID = '" & strChapterId & _
                  "' AND SubchapterID = '" & strSubchapterId & "'"
             End If
         Else
            'Title level
            If Len(strSubtitleId) = 0 Or Trim$(strSubtitleId) = "-" Then
               strSQL = "SELECT TOCChar FROM Titles WHERE TitleID = " & _
                  Val(strTitleID)
            Else
               'Subtitle level
               strSQL = "SELECT TOCChar FROM Subtitles WHERE TitleID = " & _
                  Val(strTitleID) & " AND SubtitleID = '" & strSubtitleId & "'"
            End If
         End If
      End If
   Else
      'TitlesTOC has only one record
      strSQL = "SELECT TOCText FROM TitlesTOC"
   End If
   
   With cnnCFR
      If .State = adStateClosed Then
         'Open the connection
         .CommandTimeout = 300
         .Open strConnect
      End If
   End With
   
   bln2ndPass = False
   Do
      With rstClient
         If .State = adStateOpen Then
            Close
         End If
      End With
      Set rstClient = cnnCFR.Execute(strSQL, , adCmdText)
      With rstClient
         If .EOF Then
            Exit Do
         Else
            If IsNull(.Fields(0).Value) Then
               If bln2ndPass Then
                  Exit Do
               End If
               If InStr(strSQL, "TOCChar") > 0 Then
                  strSQL = Replace$(strSQL, "TOCChar", "TOCText")
                  bln2ndPass = True
               Else
                  Exit Do
               End If
            Else
               If strTOCType = "XML" Then
                  If Len(CStr(.Fields(0).Value)) > 100 Then
                     GetTocByLevel = CStr(.Fields(0).Value)
                  Else
                     GetTocByLevel = "ERROR: Table of contents missing."
                  End If
                  GoTo TocByLevelExit
               Else
                  strDoc = CStr(.Fields(0).Value)
               End If
               Exit Do
            End If
         End If
      End With
   Loop
      
   'Release the connection early
   With rstClient
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstClient = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCFR = Nothing
   
   If Len(strDoc) > 100 Then
      GetTocByLevel = TransformXMLToc(strDoc)
   Else
      GetTocByLevel = "ERROR: Table of contents missing."
   End If
   GoTo TocByLevelExit

TocByLevelErr:
   GetTocByLevel = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo TocByLevelExit
   
TocByLevelExit:
   'Make sure objects are closed
   With rstClient
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstClient = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCFR = Nothing
End Function

Private Function TransformXMLToc(ByVal strDoc As String) As String
   'Use a process similar to that for sections to represent the TOC in HTML
   Dim domDoc As New MSXML2.DOMDocument30
   Dim domNode As MSXML2.IXMLDOMNode
   Dim domNode1 As MSXML2.IXMLDOMNode  'Title
   Dim domNode2 As MSXML2.IXMLDOMNode  'Subtitle
   Dim domNode3 As MSXML2.IXMLDOMNode  '
   Dim domNode4 As MSXML2.IXMLDOMNode
   Dim domList1 As MSXML2.IXMLDOMNodeList
   Dim domList2 As MSXML2.IXMLDOMNodeList
      
   Dim strHTML As String
   Dim strName As String
   Dim strText As String
   Dim strTemp As String
   Dim strURL As String
   Dim strId As String
   Dim strChapID As String
   Dim strClass As String
   Dim strReplace As String
   Dim strWidthPct As String
   Dim strTitle As String
   Dim strLink As String
   Dim strNav As String
   
   Dim intCtr As Integer
   Dim intNode As Integer
   Dim intPos As Integer
  
   Dim blnAddSubs As Boolean
   Dim blnIsParts As Boolean
   
   On Error GoTo TransfXMLErr
   
   'Return to titles TOC for all pages except Titles
   strLink = Space$(12) & "<tr id='titles' class='Normal'>" & vbCrLf
   strLink = strLink & Space$(15) & "<td>TITLES</td><td>Return to Titles Table of Contents and Links to Search and Help Pages</td>" & vbCrLf
   strLink = strLink & Space$(12) & "</tr>" & vbCrLf
   
   'Navigation links for titles TOC page
   strNav = Space$(12) & "<tr id='home' class='Header'>" & vbCrLf
   strNav = strNav & Space$(15) & "<td>HOME</td><td>Return to the Home Page of the OakLeaf Systems CFR Site</td>" & vbCrLf
   strNav = strNav & Space$(12) & "</tr>" & vbCrLf
   strNav = strNav & Space$(12) & "<tr id='help' class='Header'>" & vbCrLf
   strNav = strNav & Space$(15) & "<td>HELP</td><td>How to Navigate the OakLeaf Systems CFR Site</td>" & vbCrLf
   strNav = strNav & Space$(12) & "</tr>" & vbCrLf
   strNav = strNav & Space$(12) & "<tr id='search' class='Header'>" & vbCrLf
   strNav = strNav & Space$(15) & "<td>SEARCH</td><td>Conduct a Full-Text Search of CFR Tables of Contents and/or Section Text</td>" & vbCrLf
   strNav = strNav & Space$(12) & "</tr>" & vbCrLf
      
   'Page header
   strText = "Table of Contents for the U.S. Code of Federal Regulations"
   strHTML = strXMLPrefix & strXHTMLHeader & "   <head>" & vbCrLf & "      <title>" & vbCrLf
   strHTML = strHTML & Space$(9) & strText & vbCrLf & "      </title>" & vbCrLf
   strHTML = strHTML & Space$(6) & strCSSToc & "   </head>" & vbCrLf
   strHTML = strHTML & "   <body>" & vbCrLf & "      <table width='100%' border='0' cellpadding='0' cellspacing = '0' align='center'>" & vbCrLf
   strHTML = strHTML & Space$(9) & "<tr><td height='80px' width='70px' padding-left='0px' padding-right='0px'><img src='OakLeaf.gif' height='80px' width='70px' border='0' /></td>" & _
      "<td>OakLeaf Systems<br />Tables of Contents for the Online U.S. Code of Federal Regulations Delivered by<br />" & _
      "An XML Web Service from <i>Visual Basic.NET XML Web Services Developer's Guide</i><br />" & _
      "Osborne/McGraw-Hill ISBN 0-07-222369-3 (To be published in Spring 2002)</td></tr>" & vbCrLf
   strHTML = strHTML & "      </table>" & vbCrLf
   
   'Headers
   strHTML = strHTML & "      <table width='100%' border='0' align='center'>" & vbCrLf
   strHTML = strHTML & Space$(9) & "<th colspan='2'>#Placeholder#</th>" & vbCrLf
   strHTML = strHTML & Space$(9) & "<tbody style='behavior:url(CFRToc.htc)' slColor='#d0d0d0' hlColor='#e8e8e8' txColor='#266294'>" & vbCrLf
   'Provide for a row to return to the titles TOC
   strHTML = strHTML & "#TitlesLink#"
   
   domDoc.loadXML strDoc
   With domDoc
      .loadXML strDoc
      If .parseError.errorCode <> 0 Then
         'Records with undetected parse errors might be present in the database
         TransformXMLToc = "ERROR: Parse error code " & CStr(.parseError.errorCode) & ", Line: " & CStr(.parseError.Line) & ", " & .parseError.reason & vbCrLf & "Can't load document into XML DOM"
         GoTo TransfXMLErr
      End If
      Set domNode = .childNodes(1).firstChild      'Always Titles
   End With
   
   If domNode.childNodes.length > 1 Then
      'It's the Titles TOC, the highest level of the hierarchy
      blnAddSubs = True
      strHTML = Replace$(strHTML, "#Placeholder#", "Titles and Subtitles of the U.S. Code of Federal Regulations (Click an Item to Display its Chapters)")
      'Provide the navigation links
      strHTML = Replace$(strHTML, "#TitlesLink#", strNav)
   End If
   
   For intNode = 0 To domNode.childNodes.length - 1
      Set domNode1 = domNode.childNodes(intNode)         'Title
      strText = Replace(domNode1.firstChild.Text, "TITLE ", "")
      strName = "TITLE " & Left$(strText, InStr(strText, " ") - 1)
      strText = Mid$(strText, InStr(strText, " - ") + 3)
      If Trim$(strText) = "[RESERVED]" Then
         strHTML = strHTML & Space$(12) & "<tr id='reserved' class='Reserved'>" & vbCrLf
      Else
         strId = domNode1.Attributes(0).Text
         strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='Normal'>" & vbCrLf
      End If
      strHTML = strHTML & Space$(15) & "<td>" & strName & "</td>"
      strHTML = strHTML & "<td>" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf

      If domNode1.childNodes.length > 1 Then
         If domNode1.childNodes(1).firstChild.hasChildNodes Then
            If domNode1.childNodes(1).nodeName = "Subtitles" Then
               'They're subtitles, so process them
               strReplace = "Subtitle "
               strWidthPct = "15"
               Set domNode2 = domNode1.childNodes(1)
               If domNode2.childNodes.length > 1 Then
                  'Don't change the Id when returning single nodes (needed for navigation
                  strHTML = Replace$(strHTML, strId & "' class='Normal'", "hasSubs' class='HasSubs'")
               End If
               For intCtr = 0 To domNode2.childNodes.length - 1
                  strText = Replace$(domNode2.childNodes(intCtr).Text, strReplace, "")
                  If InStr(strText, vbLf) > 0 Then
                     strText = Left$(strText, InStr(strText, vbLf) - 1)
                  End If
                  strName = strReplace & Left$(strText, InStr(strText, " ") - 1)
                  strText = Mid$(strText, InStr(strText, " - ") + 3)
                  If InStr(strText, "(Parts") > 0 Then
                     strText = Trim$(Left$(strText, InStr(strText, "(Parts") - 1))
                  End If
                  If Trim$(strText) = "[Reserved]" Then
                     strHTML = strHTML & Space$(12) & "<tr id='reserved' class='Reserved'>" & vbCrLf
                  Else
                     strId = domNode2.childNodes(intCtr).Attributes(0).Text
                     strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='Normal'>" & vbCrLf
                  End If
                  strHTML = strHTML & Space$(15) & "<td width='" & strWidthPct & "%'>&#160;&#160;&#160;" & strName & "</td>"
                  strHTML = strHTML & "<td>&#160;&#160;&#160;" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
               Next intCtr
            End If
         End If
      End If
   Next intNode
   'Add the titles row for all TOCs except titles
   strHTML = Replace$(strHTML, "#TitlesLink#", strLink)
   Set domNode1 = Nothing
   Set domNode2 = Nothing
      
   'Using getElementsByTagName is a better approach for deeply-nested elements
   Set domList1 = domDoc.getElementsByTagName("Chapter")
   blnIsParts = False
   If domList1.length = 0 Then
      'Title 7A has parts, not chapters
      Set domList1 = domDoc.getElementsByTagName("Part")
      blnIsParts = True
   End If
  
   If domList1.length > 0 Then
      'Change the title (and subtitle) header(s)
      If blnIsParts Then
         strTitle = "Parts of the U.S. Code of Federal Regulations (Click a Part to Display Its Sections)"
      End If
      strHTML = Replace$(strHTML, "class='Normal'", "class='Header'")
      strHTML = Replace$(strHTML, "class='HasSubs'", "class='Header'")
      For intNode = 0 To domList1.length - 1
         Set domNode = domList1(intNode)
         If blnIsParts Then
            strText = Replace(domNode.firstChild.Text, "Part ", "")
            strName = "Part " & Left$(strText, InStr(strText, " ") - 1)
            strWidthPct = "15"
         Else
            strText = Replace(domNode.firstChild.Text, "Chapter ", "")
            strName = "Chapter " & Left$(strText, InStr(strText, " ") - 1)
            strWidthPct = "20"
         End If
         strText = Mid$(strText, InStr(strText, " - ") + 3)
         If Trim$(strText) = "[Reserved]" Then
            strId = "reserved"
            strClass = "Reserved"
            strChapID = "XXX"
         Else
            strId = domNode.Attributes(0).Text
            strChapID = Left$(strId, InStr(strId, "sc"))
            If domNode.childNodes.length > 2 Then
               strId = "hasSubs"
               strClass = "HasSubs"
               strTitle = "Chapters of the U.S. Code of Federal Regulations (Click a Chapter to Display Its Subchapters)"
            Else
               strClass = "Normal"
               strTitle = "Chapters of the U.S. Code of Federal Regulations (Click a Chapter to Display Its Parts)"
            End If
         End If
         strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='" & strClass & "'>" & vbCrLf
         strHTML = strHTML & Space$(15) & "<td width='" & strWidthPct & "%'>" & strName & "</td>"
         strHTML = strHTML & "<td>" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
         If domList1.length = 1 Then
            strHTML = Replace$(strHTML, "class='Normal'", "class='Header'")
         End If
         If domNode.childNodes.length > 1 Then
            Set domList2 = domDoc.getElementsByTagName("Subchapter")
            If domList2.length > 0 Then
               For intCtr = 0 To domList2.length - 1
                  Set domNode1 = domList2(intCtr)
                  If InStr(domNode1.Attributes(0).Text, strChapID) > 0 Then
                     strText = Replace(domNode1.firstChild.Text, "SUBCHAPTER ", "")
                     strName = "SUBCHAPTER " & Left$(strText, InStr(strText, " ") - 1)
                     strText = Mid$(strText, InStr(strText, " - ") + 3)
                     If Trim$(strText) = "[Reserved]" Then
                        strId = "reserved"
                        strClass = "Reserved"
                     Else
                        strId = domNode1.Attributes(0).Text
                        strClass = "Normal"
                     End If
                     strTitle = "Subchapters of the U.S. Code of Federal Regulations (Click for Parts)"
                     strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='" & strClass & "'>" & vbCrLf
                     strHTML = strHTML & Space$(15) & "<td width='" & strWidthPct & "%'>&#160;&#160;&#160;" & strName & "</td>"
                     strHTML = strHTML & "<td>&#160;&#160;&#160;" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
                  End If
               Next intCtr
            End If
         End If
      Next intNode
   End If
   
   If domList1.length = 1 And Not blnIsParts Then
      Set domList2 = domDoc.getElementsByTagName("Part")
      If domList2.length > 0 Then
         'Process the chapter or subchapter Parts
         If domList2.length > 1 Then
            strTitle = "Parts of the U.S. Code of Federal Regulations (Click a Part to Display Its Sections)"
         End If
         strHTML = Replace$(strHTML, "class='Normal'", "class='Header'")
         strHTML = Replace$(strHTML, "class='HasSubs'", "class='Header'")
         
         For intNode = 0 To domList2.length - 1
            Set domNode = domList2(intNode)
            strText = Replace(domNode.firstChild.Text, "Part ", "")
            strName = "Part " & Left$(strText, InStr(strText, " ") - 1)
            strWidthPct = "15"
            strText = Mid$(strText, InStr(strText, " - ") + 3)
            If Trim$(strText) = "[Reserved]" Then
               strId = "reserved"
               strClass = "Reserved"
            Else
               strId = domNode.Attributes(0).Text
               strClass = "Normal"
            End If
            strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='" & strClass & "'>" & vbCrLf
            strHTML = strHTML & Space$(15) & "<td width='" & strWidthPct & "%'>" & strName & "</td>"
            strHTML = strHTML & "<td>" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
         Next intNode
      End If
   End If
   
   If Not domList2 Is Nothing Then
      'If domList2.length = 1 Then
      If domList2.length = 1 Or blnIsParts Then
         Set domList1 = domDoc.getElementsByTagName("Section")
         If domList1.length > 0 Then
            'Process the chapter or subchapter Parts
            strTitle = "Sections of the U.S. Code of Federal Regulations (Click a Citation for Section Text)"
            strHTML = Replace$(strHTML, "class='Normal'", "class='Header'")
            strHTML = Replace$(strHTML, "class='HasSubs'", "class='Header'")
            
            For intNode = 0 To domList1.length - 1
               Set domNode = domList1(intNode)
               strText = Replace(domNode.firstChild.Text, "Section ", "")
               strName = domNode.Attributes(4).Text
               strWidthPct = "20"
               strText = Mid$(strText, InStr(strText, " - ") + 3)
               If Trim$(strText) = "[Reserved]" Then
                  strId = "reserved"
                  strClass = "Reserved"
               Else
                  If domNode.Attributes(5).Text = "Yes" Then
                     'HasText = Yes
                     strId = domNode.Attributes(0).Text
                     strClass = "Normal"
                  Else
                     'Disable click if text not available
                     strId = "noText"
                     strClass = "HasSubs"
                  End If
               End If
               strHTML = strHTML & Space$(12) & "<tr id='" & strId & "' class='" & strClass & " '>" & vbCrLf
               strHTML = strHTML & Space$(15) & "<td width='" & strWidthPct & "%'>" & strName & "</td>"
               strHTML = strHTML & "<td>" & strText & "</td>" & vbCrLf & Space$(12) & "</tr>" & vbCrLf
            Next intNode
         End If
      End If
   End If
   strHTML = strHTML & Space$(9) & "</tbody>" & vbCrLf & Space$(6) & "</table>" & vbCrLf & "   </body>" & vbCrLf & "</html>"
   
   'Now fix up the tile
   strHTML = Replace(strHTML, "#Placeholder#", strTitle)
   
   With domDoc
      'Test for parse errors
      .loadXML strHTML
      If .parseError.errorCode <> 0 Then
         strHTML = "PARSE ERROR Code: " & CStr(.parseError.errorCode) & ", Line: " & CStr(.parseError.Line) & ", " & .parseError.reason & vbCrLf & strHTML
      End If
   End With
   
   TransformXMLToc = strHTML
   GoTo TransfXMLExit

TransfXMLErr:
   TransformXMLToc = "ERROR: " & Err.Description & " (" & Err.Number & ")"
   GoTo TransfXMLExit

TransfXMLExit:
   'Clean up
   Set domDoc = Nothing
   Set domNode = Nothing
   Set domNode1 = Nothing
   Set domNode2 = Nothing
   Set domNode3 = Nothing
   Set domNode4 = Nothing
   Set domList1 = Nothing
   Set domList2 = Nothing
End Function

Private Sub Class_Terminate()
   'Clean up if terminated
   With rstClient
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstClient = Nothing
   With cnnCFR
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCFR = Nothing
End Sub
