VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFRUpdates"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Copyright (c) 2001, 2001, Roger Jennings and OakLeaf Systems
'All World-Wide Rights Reserved
'See the License.txt file in this project's folder for terms
'and conditions of use of this and other related code.

Private blnHalt As Boolean

Public Function GetPartsAffected(ByVal strConnect As String, ByVal strList As String) As String
   'Add records for parts affected today, last month, or this month
   Dim cnnCFR As New ADODB.Connection
   Dim cmmCFR As New ADODB.Command
   Dim rstUpdate As New ADODB.Recordset
   
   Dim strURL As String
   Dim strDoc As String
   Dim strMsg As String
   Dim strDateStart As String
   Dim strDateEnd As String
   Dim strDate As String
   Dim strText As String
   Dim strTemp As String
   Dim strTitleID As String
   Dim strPartID As String
   Dim strPartIdx As String
   Dim strFRPages As String
   Dim strSQL As String
   
   Dim intTitle As Integer
   Dim intCtr As Integer
   Dim intLoop As Integer
   
   Dim lngTwoCRs As Long
   Dim lngTwoLFs As Long
   
   GetPartsAffected = ""
   
   'Scrape the List of one of the CFR Parts Affected screens
   If strList = "LastMonth" Then
      strURL = "http://www.access.gpo.gov/nara/lsa/lastmth.html"
      strDateStart = "Updated "
      strDateEnd = "<"
   ElseIf strList = "CurrMonth" Then
      strURL = "http://www.access.gpo.gov/nara/lsa/curlist.html"
      strDateStart = "Updated "
      strDateEnd = "<"
   Else
      strURL = "http://www.access.gpo.gov/nara/lsa/lsatoday.html"
      strDateStart = "CFR Parts Affected in the "
      strDateEnd = ", issue of the"
   End If
   
   strDoc = GetHTMLFromURL(strURL)
   If Len(strDoc) > 500 Then
      If InStr(strDoc, strDateStart) > 0 Then
         strDoc = Mid$(strDoc, InStr(strDoc, strDateStart) + Len(strDateStart))
         If InStr(strDoc, strDateEnd) > 0 Then
            strDate = Left$(strDoc, InStr(strDoc, strDateEnd) - 1)
         Else
            'Malformed document
            GetPartsAffected = "ERROR: Malformed Parts Affected Today document"
            Exit Function
         End If
      Else
         'Wrong document
         GetPartsAffected = "ERROR: Not the Parts Affected Today document"
      Exit Function

      End If
      'Shorten the doc
      If InStr(strDoc, "<PRE>") > 0 Then
         strDoc = Mid$(strDoc, InStr(strDoc, "<PRE>") + 5)
      End If
      If InStr(strDoc, "</PRE>") > 0 Then
         strDoc = Left$(strDoc, InStr(strDoc, "</PRE>") - 1)
      End If
      
      'Convert CR/LFs to LFs (inconsistent use on page)
      strDoc = Replace$(strDoc, vbCrLf, Chr$(10))
      
      'Add a couple of returns for safety
      strDoc = strDoc & Chr$(10) & Chr$(10)
      
      With cnnCFR
         If .State = adStateClosed Then
            'Open the connection
            .CommandTimeout = 300
            .Open strConnect
            'Define a Command object
            Set cmmCFR.ActiveConnection = cnnCFR
         End If
      End With
      
      For intTitle = 1 To 50
         strTitleID = ""
         strPartID = ""
         intLoop = 0
         strTemp = " " & CStr(intTitle) & " CFR"
         If InStr(strDoc, strTemp) > 0 Then
            strDoc = Mid$(strDoc, InStr(strDoc, strTemp) + Len(strTemp) + 1)
            If Val(strDoc) > 0 Then
               'It's a section
               'Find the terminating double-space
               If InStr(strDoc, Chr$(10) & Chr$(10)) > 0 Then
                  strText = Left$(strDoc, InStr(strDoc, Chr$(10) & Chr$(10)))
                  strDoc = Mid$(strDoc, InStr(strDoc, Chr$(10) & Chr$(10)) + 2)
                  Do While Val(strText) > 0
                     intLoop = intLoop + 1   'Protection against endless loop
                     strTitleID = CStr(intTitle)
                     strPartID = CStr(Val(strText))
                     strFRPages = Left$(strText, InStr(strText, Chr$(10)))
                     strText = Mid$(strText, InStr(strText, Chr$(10)) + 1)
                     strFRPages = Mid$(strFRPages, InStrRev(strFRPages, ".") + 1)
                     strFRPages = Left$(strFRPages, InStr(strFRPages, Chr$(10)) - 1)
                     If Right$(Trim$(strFRPages), 1) = "," Then
                        Do While Right$(Trim$(strFRPages), 1) = ","
                           intLoop = intLoop + 1
                           'More pages follow on the next line (sometimes several lines)
                           If Left$(strText, 1) = " " Then
                              'Add the pages on the second line
                              strFRPages = strFRPages & Trim$(Left$(strText, InStr(strText, Chr$(10)) - 1))
                              'Remove the last line
                              strText = Mid$(strText, InStr(strText, Chr$(10)) + 1)
                           ElseIf Val(Left$(strText, 1)) > 0 Then
                              'In one case (10/10/01), the second line of the FR list
                              'had a typo (a trailing comma), which causes a unending loop
                              'Check the next line to determine if it's a part number
                              If Right(strFRPages, 1) = "," Then
                                 strFRPages = Left$(strFRPages, Len(strFRPages) - 1)
                              End If
                           End If
                           If intLoop > 5000 Then
                              'Error
                              Exit Do
                           End If
                        Loop
                     End If
                     With rstUpdate
                        'Check to see if it's a duplicate, then add the record
                        If .State = adStateOpen Then
                           .Close
                        End If
                        strSQL = "SELECT COUNT(*) FROM PartsAffected WHERE EffectiveDate = '" & _
                           strDate & "' AND TitleID = " & intTitle & " AND PartID = '" & strPartID & "'"
                        Set .ActiveConnection = cnnCFR
                        .Source = strSQL
                        .CursorLocation = adUseServer
                        .CursorType = adOpenKeyset
                        .LockType = adLockOptimistic
                        .Open
                        If CInt(rstUpdate.Fields(0).Value) = 0 Then
                           If Val(strPartID) < 10 Then
                              strPartIdx = "000" & strPartID
                           ElseIf Val(strPartID) < 100 Then
                              strPartIdx = "00" & strPartID
                           ElseIf Val(strPartID) < 1000 Then
                              strPartIdx = "0" & strPartID
                           Else
                              strPartIdx = strPartID
                           End If
                           'Add the record to the table
                           strSQL = "INSERT PartsAffected(EffectiveDate, TitleID, PartID, FRPages, PartIDSort) " & _
                              "VALUES('" & strDate & "', " & strTitleID & ", '" & strPartID & "', '" & _
                                 strFRPages & "', '" & strPartIdx & "')"
                           With cmmCFR
                              .CommandType = adCmdText
                              .CommandText = strSQL
                              .Execute
                           End With
                           intCtr = intCtr + 1
                           'Delete any earlier entries for the part
                           strSQL = "DELETE FROM PartsAffected WHERE EffectiveDate < '" & _
                              strDate & "' AND TitleID = " & intTitle & " AND PartID = '" & strPartID & "'"
                           With cmmCFR
                              .CommandType = adCmdText
                              .CommandText = strSQL
                              .Execute
                           End With
                        End If
                        .Close
                     End With
                     DoEvents
                     If intLoop > 5000 Then
                        'Error
                        Exit Do
                     End If
                  Loop
               Else
                  'Malformed document
                  GetPartsAffected = "ERROR: Malformed document"
                  Exit Function
               End If
            Else
               'It's a proposed rule, executive order, or the like (not processed)
               If InStr(strDoc, Chr$(10) & Chr$(10)) > 0 Then
                  strDoc = Mid$(strDoc, InStr(strDoc, Chr$(10) & Chr$(10)) + 2)
               End If
            End If
         End If
      Next intTitle
      If rstUpdate.State = adStateOpen Then
         rstUpdate.Close
      End If
      Set rstUpdate = Nothing
      Set cmmCFR = Nothing
      If cnnCFR.State = adStateOpen Then
         cnnCFR.Close
      End If
      Set cnnCFR = Nothing
   Else
      'Short document
      GetPartsAffected = strDoc
      Exit Function
   End If
   GetPartsAffected = CStr(intCtr)
End Function

Public Function ProcessPartsAffected(ByVal strConnect As String) As String
   'Retrieve the sections for the updated parts and add missing parts
   Dim cnnCFR As New ADODB.Connection
   Dim cmmCFR As New ADODB.Command
   Dim rstUpdates As New ADODB.Recordset
   Dim rstSections As New ADODB.Recordset
   Dim clsSection As New CFRGetSection
   
   Dim strSQL As String
   Dim strTitleID As String
   Dim strPartID As String
   Dim strSectionID As String
   Dim strEffDate As String
   Dim strRevDate As String
   Dim strUpdate As String
   
   Dim intParts As Integer
   Dim intErrors As Integer
   
   Dim lngSections As Long
   Dim lngRecords As Long
   
   Dim blnUpdate As Boolean
   Dim blnFirstDoc As Boolean
      
   With cnnCFR
      If .State = adStateClosed Then
         'Open the connection
         .CommandTimeout = 300
         .Open strConnect
         'Define a Command object
         Set cmmCFR.ActiveConnection = cnnCFR
      End If
   End With
   strSQL = "SELECT TitleID, PartID, EffectiveDate FROM PartsAffected WHERE DateProcessed IS NULL " & _
      "ORDER BY TitleID, PartIDSort"
   Set rstUpdates = cnnCFR.Execute(strSQL, , adCmdText)
   
   'The effective date must be a global variable
   blnFirstDoc = True
   With rstUpdates
      If Not .EOF Then
         Do Until .EOF
            strTitleID = CStr(.Fields(0).Value)
            strPartID = CStr(.Fields(1).Value)
            strEffDate = CStr(.Fields(2).Value)
            strSQL = "SELECT SectionID, DateRevised FROM Sections WHERE TitleID = " & strTitleID & " AND PartID = '" & strPartID & "'"
            Set rstSections = cnnCFR.Execute(strSQL, , adCmdText)
            With rstSections
               If Not .EOF Then
                  Do Until .EOF
                     strSectionID = CStr(.Fields(0).Value)
                     If IsNull(.Fields(1).Value) Then
                        blnUpdate = True
                     ElseIf CDate(.Fields(1).Value) < CDate(strEffDate) Then
                        blnUpdate = True
                     Else
                        blnUpdate = False
                     End If
                     If blnUpdate Then
                        'Retrieve the section (
                        strUpdate = clsSection.UpdateSectionText(strConnect, strTitleID, strPartID, strSectionID, "", True)
                     End If
                     If InStr(strUpdate, "ERROR:") > 0 Then
                        intErrors = intErrors + 1
                     Else
                        lngSections = lngSections + 1
                        blnFirstDoc = False
                     End If
                     .MoveNext
                     If blnHalt Then
                        Exit Do
                     End If
                  Loop
               End If
               .Close
            End With
            If blnHalt Then
               'Don't tag parts that aren't fully processed
               Exit Do
            End If
            
            'Mark the part updated
            strSQL = "UPDATE PartsAffected SET DateProcessed = '" & CStr(Date) & "' " & _
               "WHERE EffectiveDate = '" & strEffDate & "' AND TitleID = " & strTitleID & _
               "AND PartID = '" & strPartID & "'"
            With cmmCFR
               .CommandType = adCmdText
               .CommandText = strSQL
               .Execute lngRecords
            End With
            .MoveNext
            intParts = intParts + 1
         Loop
      End If
   End With
   If rstUpdates.State = adStateOpen Then
      rstUpdates.Close
   End If
   Set rstUpdates = Nothing
   Set cmmCFR = Nothing
   If cnnCFR.State = adStateOpen Then
      cnnCFR.Close
   End If
   Set cnnCFR = Nothing
   Set clsSection = Nothing
   ProcessPartsAffected = CStr(intParts) & " parts and " & _
      CStr(lngSections) & " sections updated with " & CStr(intErrors) & " errors encountered."
End Function

Public Sub HaltPartsProcessing()
   'Stop the process
   blnHalt = True
End Sub
