Attribute VB_Name = "modCFRUtils"
Option Explicit

Public gstrConnect As String
Public gcnnCFR As New ADODB.Connection
Public gcmmCFR As New ADODB.Command

Public gstrFile As String

'Full-text search variables
Public gblnFTInstalled
Public gblnFTStatsDone

Public Const gstrXMLPrefix As String = "<?xml version=""1.0"" encoding = ""UTF-8"" ?>" & vbCrLf
Public Const gstrCFRToc As String = "<CFRToc xmlns:CFRContents=""http://www.oakmont.org/CFR/Contents"" >" & vbCrLf
Public Const gstrCFRSect As String = "<CFRSect xmlns:CFRSections=""http://www.oakmont.org/CFR/Sections"" >" & vbCrLf
Public Const gstrCFRSearch As String = "<CFRSearch xmlns:CFRSections=""http://www.oakmont.org/CFR/Search"" >" & vbCrLf

Public Const INTERNET_OPEN_TYPE_PRECONFIG As Long = 0
Public Const INTERNET_OPEN_TYPE_DIRECT As Long = 1
Public Const INTERNET_OPEN_TYPE_PROXY As Long = 3

Public Const scUserAgent As String = "VB OpenUrl"
Public Const INTERNET_FLAG_RELOAD As Long = &H80000000

Public Declare Function InternetOpen Lib "wininet.dll" _
    Alias "InternetOpenA" _
   (ByVal sAgent As String, _
    ByVal lAccessType As Long, _
    ByVal sProxyName As String, _
    ByVal sProxyBypass As String, _
    ByVal lFlags As Long) As Long

Public Declare Function InternetOpenUrl Lib "wininet.dll" _
    Alias "InternetOpenUrlA" _
   (ByVal hOpen As Long, _
    ByVal strURL As String, _
    ByVal sHeaders As String, _
    ByVal lLength As Long, _
    ByVal lFlags As Long, _
    ByVal lContext As Long) As Long

Public Declare Function InternetReadFile Lib "wininet.dll" _
   (ByVal hFile As Long, _
    ByVal sBuffer As String, _
    ByVal lNumBytesToRead As Long, _
   lngNumBytes As Long) As Integer

Declare Function InternetGetLastResponseInfo Lib "wininet.dll" _
    Alias "InternetGetLastResponseInfoA" _
   (ByRef lpdwError As Long, _
    ByVal lpszErrorBuffer As String, _
    ByRef lpdwErrorBufferLength As Long) As Boolean
       
Declare Function FormatMessage Lib "kernel32" _
    Alias "FormatMessageA" _
   (ByVal dwFlags As Long, ByVal lpSource As Long, ByVal dwMessageId As Long, _
    ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, _
    Arguments As Long) As Long
 
Public Declare Function InternetCloseHandle Lib "wininet.dll" _
(ByVal hInet As Long) As Integer

Public Function GetHTMLFromURL(strURL As String) As String
   'Retrieves the page designated by strURL
   'This code is based on the "ITC OpenUrl Method Does Not Return Complete Files"
   'Knowledge Base article at http://support.microsoft.com/support/kb/articles/Q232/1/94.ASP
   Dim strHTML As String
   Dim hOpen As Long
   Dim hOpenUrl As Long
   Dim blnRetVal As Boolean
   Dim strBuffer As String * 2048
   Dim lngNumBytes As Long
   
   On Error GoTo HTMLFromURLErr
   
   hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
   If hOpen = 0 Then
      strHTML = "ERROR: " & ErrDescr(Err.LastDllError)
   Else
      hOpenUrl = InternetOpenUrl(hOpen, strURL, vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
      If hOpenUrl = 0 Then
         strHTML = "ERROR: " & ErrDescr(Err.LastDllError)
      Else
         Do
            strBuffer = ""
            blnRetVal = InternetReadFile(hOpenUrl, strBuffer, Len(strBuffer), lngNumBytes)
            strHTML = strHTML & Left$(strBuffer, lngNumBytes)
            If lngNumBytes = 0 Then
              Exit Do
            End If
         Loop
      End If
   End If
   If hOpenUrl <> 0 Then
      InternetCloseHandle (hOpenUrl)
   End If
   If hOpen <> 0 Then
      InternetCloseHandle (hOpen)
   End If
   
   GetHTMLFromURL = strHTML
   Exit Function

HTMLFromURLErr:
   'Errors usually are timeouts
   GetHTMLFromURL = "ERROR: " & Err.Description & " (" & CStr(Err.Number) & ")"
   Exit Function
End Function

Private Function ErrDescr(ByVal lngError As Long) As String
   'Translate error codes returned by Err.LastDllError
   'This function covers all common errors
   Select Case lngError
      Case 12001
         ErrDescr = "No more handles can be generated at this time"
      Case 12002
         ErrDescr = "The request has timed out."
      Case 12003
         ErrDescr = "An extended error was returned from the server."
      Case 12004
         ErrDescr = "An internal error has occurred."
      Case 12005
         ErrDescr = "The URL is invalid."
      Case 12006
         ErrDescr = "The URL scheme could not be recognized, or is not supported."
      Case 12007
         ErrDescr = "The server name could not be resolved."
      Case 12008
         ErrDescr = "The requested protocol could not be located."
      Case 12009
         ErrDescr = "A request to InternetQueryOption or InternetSetOption specified an invalid option value."
      Case 12010
         ErrDescr = "The length of an option supplied to InternetQueryOption or InternetSetOption is incorrect for the type of option specified."
      Case 12011
         ErrDescr = "The request option can not be set, only queried."
      Case 12012
         ErrDescr = "The Win32 Internet support is being shutdown or unloaded."
      Case 12013
         ErrDescr = "The request to connect and login to an FTP server could not be completed because the supplied user name is incorrect."
      Case 12014
         ErrDescr = "The request to connect and login to an FTP server could not be completed because the supplied password is incorrect. "
      Case 12015
         ErrDescr = "The request to connect to and login to an FTP server failed."
      Case 12016
         ErrDescr = "The requested operation is invalid. "
      Case 12017
         ErrDescr = "The operation was canceled, usually because the handle on which the request was operating was closed before the operation completed."
      Case 12018
         ErrDescr = "The type of handle supplied is incorrect for this operation."
      Case 12019
         ErrDescr = "The requested operation can not be carried out because the handle supplied is not in the correct state."
      Case 12020
         ErrDescr = "The request can not be made via a proxy."
      Case 12021
         ErrDescr = "A required registry value could not be located. "
      Case 12022
         ErrDescr = "A required registry value was located but is an incorrect type or has an invalid value."
      Case 12023
         ErrDescr = "Direct network access cannot be made at this time. "
      Case 12024
         ErrDescr = "An asynchronous request could not be made because a zero context value was supplied."
      Case 12025
         ErrDescr = "An asynchronous request could not be made because a callback function has not been set."
      Case 12026
         ErrDescr = "The required operation could not be completed because one or more requests are pending."
      Case 12027
         ErrDescr = "The format of the request is invalid."
      Case 12028
         ErrDescr = "The requested item could not be located."
      Case 12029
         ErrDescr = "The attempt to connect to the server failed."
      Case 12030
         ErrDescr = "The connection with the server has been terminated."
      Case 12031
         ErrDescr = "The connection with the server has been reset."
      Case 12036
         ErrDescr = "The request failed because the handle already exists."
      Case Else
         ErrDescr = "Error information not available."
   End Select
End Function

Public Function Roman2Arabic(ByVal strRomNum As String) As Long
   'Convert Roman chapter numbers to Arabic
   Dim strPrevChar As String
   Dim strCurrChar As String
   Dim strNextChar As String
   Dim lngSize As Long
   Dim intCtr As Integer

   For intCtr = 1 To Len(strRomNum) Step 2
      strCurrChar = Mid(strRomNum, intCtr, 1)
      strNextChar = Mid(strRomNum, intCtr + 1, 1)
      On Local Error Resume Next
      strPrevChar = IIf(intCtr = 1, " ", Mid(strRomNum, intCtr - 1, 1))
      On Error GoTo 0
      If NumeralValue(strNextChar) > NumeralValue(strCurrChar) Then
         lngSize = lngSize + (NumeralValue(strNextChar) - NumeralValue(strCurrChar))
      Else
         lngSize = lngSize + NumeralValue(strCurrChar)
      intCtr = intCtr - 1
      End If
   Next intCtr
   Roman2Arabic = lngSize
End Function

Private Function NumeralValue(ByVal strNumeral As String) As Long
   'Helper function for Roman2Arabic
   Select Case strNumeral
      Case "I"
         NumeralValue = 1
      Case "V"
         NumeralValue = 5
      Case "X"
         NumeralValue = 10
      Case "L"
         NumeralValue = 50
      Case "C"
         NumeralValue = 100
      Case "D"
         NumeralValue = 500
      Case "M"
         NumeralValue = 1000
   End Select
End Function

Public Function Arabic2Roman(ByVal intNum As Integer) As String
    'Convert numeric chapter IDs into Roman numerals

    Dim strArabic(12) As Integer
    Dim strRoman(12) As String
    Dim intCtr As Integer
    Dim strRom As String

    strArabic(0) = 1000
    strArabic(1) = 900
    strArabic(2) = 500
    strArabic(3) = 400
    strArabic(4) = 100
    strArabic(5) = 90
    strArabic(6) = 50
    strArabic(7) = 40
    strArabic(8) = 10
    strArabic(9) = 9
    strArabic(10) = 5
    strArabic(11) = 4
    strArabic(12) = 1
    strRoman(0) = "M"
    strRoman(1) = "CM"
    strRoman(2) = "D"
    strRoman(3) = "CD"
    strRoman(4) = "C"
    strRoman(5) = "XC"
    strRoman(6) = "L"
    strRoman(7) = "XL"
    strRoman(8) = "X"
    strRoman(9) = "IX"
    strRoman(10) = "V"
    strRoman(11) = "IV"
    strRoman(12) = "I"

    intCtr = 0
    Do While intNum
        Do While intNum >= strArabic(intCtr)
            intNum = intNum - strArabic(intCtr)
            strRom = strRom + strRoman(intCtr)
        Loop
        intCtr = intCtr + 1
    Loop
    Arabic2Roman = strRom
End Function

'******************
'Utility Functions
'******************

Public Function ToILC(strCaps As String) As String
   'Convert all caps text to initial-letter capitalized to fit in list boxes
   'and improve readability
   'This function isn't perfect (it has a problem with Roman numerals,
   'agency abbreviations, and other non-standard text
   Dim intPos As Integer
   Dim strTest As String
   
   strTest = Left$(strCaps, 1)
   For intPos = 2 To Len(strCaps)
      'If Mid$(strCaps, intPos - 1, 1) = " " Or Mid$(strCaps, intPos - 1, 1) = "[" Then
      If InStr(Chr$(32) & "-([", Mid$(strCaps, intPos - 1, 1)) Then
         strTest = strTest & Mid$(strCaps, intPos, 1)
      Else
         strTest = strTest & LCase$(Mid$(strCaps, intPos, 1))
      End If
   Next intPos
   'Conjunctions, articles, and prepositions
   strTest = Replace$(strTest, " And ", " and ")
   strTest = Replace$(strTest, " Or ", " or ")
   strTest = Replace$(strTest, " The ", " the ")
   strTest = Replace$(strTest, " A ", " a ")
   strTest = Replace$(strTest, " An ", " an ")
   strTest = Replace$(strTest, " Of ", " of ")
   strTest = Replace$(strTest, " For ", " for ")
   strTest = Replace$(strTest, " In ", " in ")
   strTest = Replace$(strTest, " On ", " on ")
   strTest = Replace$(strTest, " With ", " with ")
   
   'Agency and other abbreviations
   strTest = Replace$(strTest, "U.s.c", "U.S.C")
   strTest = Replace$(strTest, "U.s.", "U.S.")
   strTest = Replace$(strTest, " Dod ", " DoD ")
   strTest = Replace$(strTest, " Omb ", " OMB ")
   strTest = Replace$(strTest, " Opm ", " OPM ")
   ToILC = strTest
End Function

